PRINT N'Dropping [dbo].[DF_Table_1_ID]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_Table_1_ID];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_TotalAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalAudio];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_ValidTotalAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalAudio];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_InvalidTotalAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_InvalidTotalAudio];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedAudio];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadyDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyDurationTime];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadyRoundedDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyRoundedDurationTime];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadeTranscribedRoundedDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadeTranscribedRoundedDurationTime];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_DurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_DurationTime];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_ValidDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidDurationTime];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedDurationTime];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_RoundedDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_RoundedDurationTime];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_TotalQueries]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalQueries];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_ValidTotalQueries]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalQueries];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_QueryRequest]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_QueryRequest];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_TotalModels]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalModels];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_CreatedByRemoteUser]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_CreatedByRemoteUser];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_StimatedRequestsPerModel]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_StimatedRequestsPerModel];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_ValidTotalModels]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalModels];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_ModelRequest]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_ModelRequest];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_IsFinished]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_IsFinished];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_Status]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_Status];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCGeneralTransaction_CreatedDate]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_CreatedDate];


GO
PRINT N'Starting rebuilding table [dbo].[AccountSubAccountVCCSummaryTransaction]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_AccountSubAccountVCCSummaryTransaction] (
    [BatchID]                               VARCHAR (100)   CONSTRAINT [DF_Table_1_ID] DEFAULT (newid()) NOT NULL,
    [InstallationId]                        VARCHAR (50)    NOT NULL,
    [VCC]                                   VARCHAR (50)    NOT NULL,
    [BatchTypeName]                         VARCHAR (50)    NOT NULL,
    [BatchTypeId]                           VARCHAR (50)    NULL,
    [SystemService]                         VARCHAR (50)    NOT NULL,
    [Rate]                                  AS              ([dbo].[BatchSummaryTransactionRateCalculate]([BatchId], [SystemService])),
    [TotalAudio]                            INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalAudio] DEFAULT ((0)) NULL,
    [ValidTotalAudio]                       INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalAudio] DEFAULT ((0)) NOT NULL,
    [InvalidTotalAudio]                     INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_InvalidTotalAudio] DEFAULT ((0)) NULL,
    [AlreadyTranscribedAudio]               INT             CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedAudio] DEFAULT ((0)) NULL,
    [AlreadyDurationTime]                   INT             CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyDurationTime] DEFAULT ((0)) NULL,
    [AlreadyRoundedDurationTime]            INT             CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyRoundedDurationTime] DEFAULT ((0)) NULL,
    [AlreadyTranscribedDurationTime]        INT             CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedDurationTime] DEFAULT ((0)) NULL,
    [AlreadyTranscribedRoundedDurationTime] INT             CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadeTranscribedRoundedDurationTime] DEFAULT ((0)) NULL,
    [DurationTime]                          INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_DurationTime] DEFAULT ((0)) NULL,
    [ValidDurationTime]                     INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidDurationTime] DEFAULT ((0)) NULL,
    [RoundedDurationTime]                   INT             CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_RoundedDurationTime] DEFAULT ((0)) NULL,
    [TranscriptionRatePerSecond]            DECIMAL (18, 5) NULL,
    [TotalQueries]                          INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalQueries] DEFAULT ((0)) NULL,
    [ValidTotalQueries]                     INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalQueries] DEFAULT ((0)) NULL,
    [TotalQueryRequest]                     INT             CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_QueryRequest] DEFAULT ((0)) NULL,
    [SemanticAnalysisRatePerTransaction]    DECIMAL (18, 5) NULL,
    [TotalModels]                           INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalModels] DEFAULT ((0)) NULL,
    [EstimatedRequestsPerModel]             DECIMAL (18, 5) CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_StimatedRequestsPerModel] DEFAULT ((0)) NULL,
    [EstimatedModelRequests]                DECIMAL (18, 5) NULL,
    [ValidTotalModels]                      INT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalModels] DEFAULT ((0)) NULL,
    [TotalModelRequest]                     INT             CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_ModelRequest] DEFAULT ((0)) NULL,
    [CognitiveAnalysisRatePerTransaction]   DECIMAL (18, 5) NULL,
    [ProcessId]                             VARCHAR (100)   NULL,
    [TemplateId]                            VARCHAR (50)    NULL,
    [UserApi]                               VARCHAR (50)    NULL,
    [StartDate]                             DATETIME        NULL,
    [EndDate]                               DATETIME        NULL,
    [IsFinished]                            BIT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_IsFinished] DEFAULT ((0)) NOT NULL,
    [Status]                                VARCHAR (50)    CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_Status] DEFAULT ('CREATED') NULL,
    [CreatedDate]                           DATETIME        CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_CreatedDate] DEFAULT (getutcdate()) NOT NULL,
    [CreatedByuserId]                       VARCHAR (50)    NULL,
    [CreatedByRemoteUser]                   BIT             CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_CreatedByRemoteUser] DEFAULT ((1)) NULL,
    [LasModifiedDate]                       DATETIME        NULL,
    [LastModifiedByUserId]                  VARCHAR (50)    NULL,
    [LastModifiedByRemoteUser]              BIT             NULL,
    [TimeStamp]                             DATETIME        NOT NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_AccountSubAccountVCCGeneralTransaction1] PRIMARY KEY CLUSTERED ([BatchID] ASC, [SystemService] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[AccountSubAccountVCCSummaryTransaction])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_AccountSubAccountVCCSummaryTransaction] ([BatchID], [SystemService], [InstallationId], [VCC], [BatchTypeName], [BatchTypeId], [TotalAudio], [ValidTotalAudio], [InvalidTotalAudio], [AlreadyTranscribedAudio], [AlreadyDurationTime], [AlreadyRoundedDurationTime], [AlreadyTranscribedDurationTime], [AlreadyTranscribedRoundedDurationTime], [DurationTime], [ValidDurationTime], [RoundedDurationTime], [TranscriptionRatePerSecond], [TotalQueries], [ValidTotalQueries], [TotalQueryRequest], [SemanticAnalysisRatePerTransaction], [TotalModels], [EstimatedRequestsPerModel], [ValidTotalModels], [TotalModelRequest], [CognitiveAnalysisRatePerTransaction], [ProcessId], [TemplateId], [UserApi], [StartDate], [EndDate], [IsFinished], [Status], [CreatedDate], [CreatedByuserId], [CreatedByRemoteUser], [LasModifiedDate], [LastModifiedByUserId], [LastModifiedByRemoteUser], [TimeStamp])
        SELECT   [BatchID],
                 [SystemService],
                 [InstallationId],
                 [VCC],
                 [BatchTypeName],
                 [BatchTypeId],
                 [TotalAudio],
                 [ValidTotalAudio],
                 [InvalidTotalAudio],
                 [AlreadyTranscribedAudio],
                 [AlreadyDurationTime],
                 [AlreadyRoundedDurationTime],
                 [AlreadyTranscribedDurationTime],
                 [AlreadyTranscribedRoundedDurationTime],
                 [DurationTime],
                 [ValidDurationTime],
                 [RoundedDurationTime],
                 [TranscriptionRatePerSecond],
                 [TotalQueries],
                 [ValidTotalQueries],
                 [TotalQueryRequest],
                 [SemanticAnalysisRatePerTransaction],
                 [TotalModels],
                 [EstimatedRequestsPerModel],
                 [ValidTotalModels],
                 [TotalModelRequest],
                 [CognitiveAnalysisRatePerTransaction],
                 [ProcessId],
                 [TemplateId],
                 [UserApi],
                 [StartDate],
                 [EndDate],
                 [IsFinished],
                 [Status],
                 [CreatedDate],
                 [CreatedByuserId],
                 [CreatedByRemoteUser],
                 [LasModifiedDate],
                 [LastModifiedByUserId],
                 [LastModifiedByRemoteUser],
                 [TimeStamp]
        FROM     [dbo].[AccountSubAccountVCCSummaryTransaction]
        ORDER BY [BatchID] ASC, [SystemService] ASC;
    END

DROP TABLE [dbo].[AccountSubAccountVCCSummaryTransaction];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_AccountSubAccountVCCSummaryTransaction]', N'AccountSubAccountVCCSummaryTransaction';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_AccountSubAccountVCCGeneralTransaction1]', N'PK_AccountSubAccountVCCGeneralTransaction', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Altering [dbo].[AccountSubAccountVCCBatchSummaryClose]...';


GO
ALTER PROCEDURE [dbo].[AccountSubAccountVCCBatchSummaryClose](
	@BatchId VARCHAR(50) = NULL, 
	@ClosedDate DATETIME = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
		IF @BatchId IS NULL 
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS SYSTEMSERVICE RELACIONADOS AL BATCH
		DECLARE MY_CURSOR CURSOR 
		LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
			-- CONSULTAMOS LOS SYSTEMSERVICE DEL BATCH PARA LA ACTUALIZACION DE SALDOS
			SELECT ASAVST.[InstallationId],
					ASAVST.[VCC], 
					ASAVST.[SystemService], 
					ASAVST.[Rate]
				FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST 
				WHERE ASAVST.[BatchID] = @BatchId

		-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL BACTH ACTUAL QUE ESTAMOS RECORRIENDO
		DECLARE @CURRENT_INSTALLATION_ID VARCHAR(50) = ''
		DECLARE @CURRENT_VCC VARCHAR(50) = ''
		DECLARE @CURRENT_SYSTEM_SERVICE VARCHAR(50) = ''
		DECLARE @CURRENT_RATE DECIMAL(18, 5) = 0

		-- DECLARAMOS VARIABLES DE AYUDA QUE CAMBIARAN EN EL BUCLE
		DECLARE @MOVEMENT_DESCRIPTION VARCHAR(250) = NULL
		DECLARE @BATCH_TOTAL_STEPS INT = 0
		DECLARE @BATCH_CURRENT_STEP INT = 0
		DECLARE @INITIAL_CALCULATED_AMOUNT DECIMAL(18,5) = 0
		DECLARE @FINAL_CALCULATED_AMOUNT DECIMAL(18,5) = 0

		
		-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
		OPEN MY_CURSOR
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_INSTALLATION_ID, @CURRENT_VCC, @CURRENT_SYSTEM_SERVICE, @CURRENT_RATE
		WHILE @@FETCH_STATUS = 0
		BEGIN 
			-- OBTENEMOS LOS DATOS GENERALES DEL BATCH EN LA TABLA DE MOVIMIENTOS
			SELECT @BATCH_CURRENT_STEP = MAX(ASAVBM.[CurrentStep]),
					@BATCH_TOTAL_STEPS = ASAVBM.[TotalSteps]
				FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK)
				WHERE ASAVBM.[BatchID] = @BatchId
				GROUP BY ASAVBM.[InstallationId], ASAVBM.[VCC], ASAVBM.[TotalSteps]

			-- OBTENEMOS LOS DATOS ESPECIFICOS DEL BATCH-SYSTEMSERVICE EN LA TABLA DE MOVIMIENTOS
			SELECT @INITIAL_CALCULATED_AMOUNT = ASAVBM.[Amount]
				FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK)
				WHERE ASAVBM.[BatchID] = @BatchId
					AND ASAVBM.[InstallationId] = @CURRENT_INSTALLATION_ID
					AND ASAVBM.[Wallet] = @CURRENT_SYSTEM_SERVICE

			-- PARA REGISTRAR LOS MOVIMIENTOS AUMENTAMOS EL CURRENT_STEP PARA REGISTRAR EL SIGUIENTE MOVIMIENTO
			SET @BATCH_CURRENT_STEP = @BATCH_CURRENT_STEP + 1

			-- DEFINIMOS LA DESCRIPCION DEL MOVIMIENTO DEBITAJE
			SET @MOVEMENT_DESCRIPTION = CONCAT('VCC ', @CURRENT_VCC, ': DEBT $', @CURRENT_RATE, ' FROM ', @CURRENT_SYSTEM_SERVICE, ' WALLET ON CLOSING BATCH')

			-- INSERTAMOS EN LA TABLA ACCOUNSUBACCOUNTVCCBALANCEMOVEMENT EL REGISTRO PARA EL COBRO A LA CARTERA RECORRIDA
			INSERT INTO [dbo].[AccountSubAccountVCCBalanceMovement] 
						([ID] ,[InstallationId] ,[AccountId] ,[SubAccountId] ,[VCC]
						,[Wallet] ,[Type] ,[CurrentStep] ,[TotalSteps] ,[Description]
						,[BatchId] ,[Amount]
						,[PrevAvailableBalance] ,[PostAvailableBalance] 
						,[PrevCountableBalance] ,[PostCountableBalance] 
						,[TimeStamp])
				SELECT @BatchId ,AVB.[InstallationId] ,AVB.[AccountId] ,AVB.[SubAccountId] ,AVB.[VCC]
						,AVB.[SystemService] ,'DEBT' ,@BATCH_CURRENT_STEP ,@BATCH_TOTAL_STEPS ,@MOVEMENT_DESCRIPTION
						,@BatchId ,@CURRENT_RATE
						,AVB.[AvailableBalance] ,AVB.[AvailableBalance]
						,AVB.[CountableBalance] ,AVB.[CountableBalance] - @CURRENT_RATE 
						,GETUTCDATE()
					FROM [dbo].[AccountVCCBalance] AVB (NOLOCK)
					WHERE [InstallationId] = @CURRENT_INSTALLATION_ID 
						AND [VCC] = @CURRENT_VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE
						--AND [CountableBalance] > @FINAL_CALCULATED_AMOUNT

			-- DESBLOQUEMOS EL REGISTRO DE SALDOS DEL SERVICO USANDO LOS MISMO PARAMETROS DE BUSQUEDA Y ACTUALIZAMOS EL SALDO DISPONIBLE Y CONTABLE
			UPDATE [dbo].[AccountVCCBalance] 
				SET [IsLocked] = 0, 
					[AvailableBalance] = [AvailableBalance] + (@INITIAL_CALCULATED_AMOUNT - @CURRENT_RATE),
					[RetainedBalance] = [RetainedBalance] - @INITIAL_CALCULATED_AMOUNT,
					[CountableBalance] = [CountableBalance] - @CURRENT_RATE,
					--[LastModifiedByUserId] = @UserApi,
					[LastModifiedDate] = GETUTCDATE(),
					[TimeStamp] = GETUTCDATE() 
				WHERE [InstallationId] = @CURRENT_INSTALLATION_ID 
					AND [VCC] = @CURRENT_VCC
					AND [SystemService] = @CURRENT_SYSTEM_SERVICE

			-- AUMENTAMOS EL CURRENT_STEP PARA REGISTRAR EL SIGUIENTE MOVIMIENTO
			SET @BATCH_CURRENT_STEP = @BATCH_CURRENT_STEP + 1

			-- DEFINIMOS LA DESCRIPCION DEL MOVIMIENTO LIBERAR
			SET @MOVEMENT_DESCRIPTION = CONCAT('VCC ', @CURRENT_VCC, ': RELEASE $', (@INITIAL_CALCULATED_AMOUNT - @CURRENT_RATE), ' FROM ', @CURRENT_SYSTEM_SERVICE, ' WALLET ON CLOSING BATCH')
			
			-- INSERTAMOS EN LA TABLA ACCOUNSUBACCOUNTVCCBALANCEMOVEMENT EL REGISTRO PARA LA LIBERACION DE SALDO RETENIDO A LA CARTERA RECORRIDA
			INSERT INTO [dbo].[AccountSubAccountVCCBalanceMovement] 
						([ID] ,[InstallationId] ,[AccountId] ,[SubAccountId] ,[VCC]
						,[Wallet] ,[Type] ,[CurrentStep] ,[TotalSteps] ,[Description]
						,[BatchId] ,[Amount]
						,[PrevAvailableBalance] ,[PostAvailableBalance] 
						,[PrevCountableBalance] ,[PostCountableBalance] 
						,[TimeStamp])
				SELECT @BatchId ,AVB.[InstallationId] ,AVB.[AccountId] ,AVB.[SubAccountId] ,AVB.[VCC]
						,AVB.[SystemService] ,'RELEASE' ,@BATCH_CURRENT_STEP ,@BATCH_TOTAL_STEPS ,@MOVEMENT_DESCRIPTION
						,@BatchId ,@INITIAL_CALCULATED_AMOUNT - @CURRENT_RATE
						,AVB.[AvailableBalance] ,AVB.[AvailableBalance] + (@INITIAL_CALCULATED_AMOUNT - @CURRENT_RATE)
						,AVB.[CountableBalance] ,AVB.[CountableBalance] 
						,GETUTCDATE()
					FROM [dbo].[AccountVCCBalance] AVB (NOLOCK)
					WHERE [InstallationId] = @CURRENT_INSTALLATION_ID 
						AND [VCC] = @CURRENT_VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE

			-- ACTUALIZAR EL BATCH COMO ISFINISHED TRUE EN CASO NO HAYA SIDO MARCADO TODAVIA
			UPDATE [dbo].[AccountSubAccountVCCSummaryTransaction]
				SET [IsFinished] = 1,
					[EndDate] = CASE WHEN @ClosedDate IS NULL THEN [EndDate] ELSE @ClosedDate END,
					[Status] = 'FINISHED', -- ESTE ESTADO SE CAMBIARA PARA DAR OPCION A FINISHED COMO COMPLETADO SIN INTERVENSION O FINISHED_BY_USER CUANDO EL USUARIO DECIDE TERMINARLO
					[LasModifiedDate] = GETUTCDATE(),
					[TimeStamp] = GETUTCDATE()
				WHERE [InstallationId] = @CURRENT_INSTALLATION_ID 
					AND [BatchID] = @BatchId
					AND [VCC] = @CURRENT_VCC
					AND [SystemService] = @CURRENT_SYSTEM_SERVICE
					--AND [IsFinished] = 0
					AND [Status] NOT IN ('FINISHED')

			FETCH NEXT FROM MY_CURSOR INTO @CURRENT_INSTALLATION_ID, @CURRENT_VCC, @CURRENT_SYSTEM_SERVICE, @CURRENT_RATE
		END
		CLOSE MY_CURSOR
		DEALLOCATE MY_CURSOR

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetBatchBalanceDetail]...';


GO
ALTER PROCEDURE [dbo].[GetBatchBalanceDetail](
	@PlatformHash VARCHAR(100) = NULL,
	@InstallationId VARCHAR(100) = NULL,
	@VCC VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- VALIDAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
		IF @PlatformHash IS NULL 
			OR @InstallationId IS NULL 
			OR @VCC IS NULL 
			OR @BatchTypeName IS NULL 
			OR @BatchTypeId IS NULL 
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		-- VERIFICAMOS QUE EL BATCH TYPE SEA UN TIPO CONOCIDO DEL SISTEMA
		IF @BatchTypeName <> 'TRANSCRIPTION' AND @BatchTypeName <> 'STUDY' AND @BatchTypeName <> 'EVALUATION_PLAN'
			-- LANZAMOS MENSAJE AVISANDO QUE HAN SOLICITADO UNA OPERACION DESCONOCIDA
			RAISERROR('DATABASE_ERROR_UNKNOWN_BATCH_TYPE', 16, 16)

		-- DEFINIMOS EL TIEMPO EN HORAS PARA CERRAR UN BATCH AUTOMATICAMENTE (SI SE MODIFICA, MODIFICAR TAMBIEN EN EL SP GETPLATFORMCURRENTBATCHES)
		DECLARE @HOURS_TO_CLOSE_PAUSED_BATCH_SUMMARY DECIMAL(18,5) = 72

		--SELECT * FROM [dbo].[AccountSubAccountVCCSummaryTransaction] (NOLOCK)
		--SELECT * FROM [dbo].[AccountSubAccountVCCDetailedTransaction] (NOLOCK) 
		--SELECT * FROM [dbo].[AccountSubAccountVCCBalanceMovement] (NOLOCK) 

		-- HACEMOS UN SELECT A LOS SERVICIOS DEL BATCH, SU AVANCE ACTUAL, MONTO RETENIDO
		SELECT ASAVST.[BatchID]						'batchId',
				ASAVST.[BatchTypeName]				'batchTypeName',
				ASAVST.[BatchTypeId]				'batchTypeId',
				ASAVST.[SystemService]				'systemService', 
				CASE WHEN ASAVST.[SystemService] = 'TRANSCRIPTION' THEN ASAVST.[DurationTime] - ASAVST.[AlreadyDurationTime]
					WHEN ASAVST.[SystemService] = 'SEMANTIC_ANALYSIS' THEN ASAVST.[TotalQueries]
					--WHEN ASAVST.[SystemService] = 'COGNITIVE_ANALYSIS' THEN ASAVST.[TotalModels] * ASAVST.[EstimatedRequestsPerModel]
					WHEN ASAVST.[SystemService] = 'COGNITIVE_ANALYSIS' THEN ASAVST.[EstimatedModelRequests]
					END								'estimated',
				CASE WHEN ASAVST.[SystemService] = 'TRANSCRIPTION' THEN SUM(ASAVDT.[ValidDurationTime])
					WHEN ASAVST.[SystemService] = 'SEMANTIC_ANALYSIS' THEN SUM(CASE WHEN ASAVDT.[IsValid] = 1 THEN 1 ELSE 0 END)
					WHEN ASAVST.[SystemService] = 'COGNITIVE_ANALYSIS' THEN SUM(ASAVDT.[TotalValidRequest])
					END								'progress',
				CASE WHEN ASAVST.[SystemService] = 'TRANSCRIPTION' THEN SUM(CASE WHEN ASAVDT.[Description] <> 'SUCCED' THEN ASAVDT.[DurationTime] ELSE 0 END)
					WHEN ASAVST.[SystemService] = 'SEMANTIC_ANALYSIS' THEN SUM(CASE WHEN ASAVDT.[IsValid] = 0 THEN 1 ELSE 0 END)
					WHEN ASAVST.[SystemService] = 'COGNITIVE_ANALYSIS' THEN SUM(ASAVDT.[TotalInvalidRequest])
					END								'failed',
				SUM(ASAVDT.[Rate])					'rated',
				ASAVBM.[Amount]						'retained',
				COUNT(ASAVDT.[BatchId])				'batchDetails',
				ASAVST.[Status]						'batchStatus',
				--AVB.[CountableBalance]				'countableBalance',
				--AVB.[AvailableBalance]				'availableBalance',
				--AVB.[RetainedBalance]				'retainedBalance',
				CASE WHEN (AVB.[AvailableBalance] - SUM(ASAVDT.[Rate])) >= (ASAVBM.[Amount] - SUM(ASAVDT.[Rate])) THEN 1 ELSE 0 END 'sufficientBalance',
				ASAVST.[LasModifiedDate]			'lastModifiedDate',
				--DATEADD(HOUR , 72 , ASAVST.[LasModifiedDate])	'closeDate'
				DATEDIFF(SECOND, CURRENT_TIMESTAMP, DATEADD(HOUR , @HOURS_TO_CLOSE_PAUSED_BATCH_SUMMARY , ASAVST.[LasModifiedDate])) 'closeDate'
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK) 
			LEFT JOIN [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT (NOLOCK) 
				ON ASAVDT.[InstallationId] = ASAVST.[InstallationId]
					AND ASAVDT.[BatchId] = ASAVST.[BatchId]
					AND ASAVDT.[BatchTypeName] =  ASAVST.[BatchTypeName]
					AND ASAVDT.[SystemService] = ASAVST.[SystemService]
			INNER JOIN [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK) 
				ON ASAVBM.[InstallationId] = ASAVST.[InstallationId]
					AND ASAVBM.[VCC] = ASAVST.[VCC]
					AND ASAVBM.BatchId = ASAVST.[BatchId]
					AND ASAVBM.[Wallet] = ASAVST.[SystemService]
			INNER JOIN [dbo].[AccountVCCBalance] AVB  (NOLOCK) 
				ON AVB.[InstallationId] = ASAVST.[InstallationId]
					AND AVB.[AccountId] = ASAVBM.[AccountId]
					AND AVB.[VCC] = ASAVST.[VCC]
					AND AVB.[SystemService] = ASAVST.[SystemService]
 			WHERE ASAVST.[InstallationId] = @InstallationId
				AND ASAVST.[VCC] = @VCC
				AND ASAVST.[BatchTypeName] = @BatchTypeName 
				AND ASAVST.[BatchTypeId] = @BatchTypeId
				AND ASAVBM.[Type] = 'RETAIN'
			GROUP BY ASAVST.[BatchId],
					ASAVST.[BatchTypeName],
					ASAVST.[BatchTypeId],
					ASAVST.[SystemService],
					ASAVST.[CreatedDate],
					ASAVST.[DurationTime],
					ASAVST.[AlreadyDurationTime],
					ASAVST.[TotalQueries],
					ASAVST.[TotalModels],
					--ASAVST.[EstimatedRequestsPerModel],
					ASAVST.[EstimatedModelRequests],
					ASAVST.[LasModifiedDate],
					ASAVBM.[Amount],
					ASAVST.[Status],
					AVB.[CountableBalance],
					AVB.[AvailableBalance],
					AVB.[RetainedBalance]
			ORDER BY ASAVST.[CreatedDate] ASC

	END TRY
    BEGIN CATCH
        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT ON
END
GO
PRINT N'Altering [dbo].[GetCognitiveAnalysisAverageRequestPerMinute]...';


GO
ALTER PROCEDURE [dbo].[GetCognitiveAnalysisAverageRequestPerMinute](
	@InstallationId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE RETORNAR UN NUMERO PROMEDIO DE REQUEST DE ANALISIS COGNITIVO EN UN MINUTO
	-- USADO POR [dbo].[AccountSubAccountVCCBatchSummaryCreate] Y [dbo].[GetAccountVccRates]
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL VALOR DE SEGUNDOS POR REQUEST
		DECLARE @SECONDS_PER_REQUEST DECIMAL(5,2) = 0

		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL VALOR DE REQUEST POR MINUTO
		DECLARE @REQUEST_PER_MINUTE DECIMAL(5,2) = 0
		
		-- *TASA DE SEGURO DE FACTURACION(DECIMAL): SI SE CAMBIA ESTE VALOR, SE DEBERA CAMBIAR TAMBIEN EN EL SP [dbo].[AccountSubAccountVCCBatchSummaryCreate]
		DECLARE @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE DECIMAL(5, 2) = 0.15

		-- DECLARAMOS LAS VARIABLES PARA LOS RESULTADOS TOTALES
		DECLARE @TOTAL_AUDIOS DECIMAL(18, 5) = 0
		DECLARE @TOTAL_DURATION_TIME DECIMAL(18, 5) = 0
		DECLARE @TOTAL_VALID_DURATION_TIME DECIMAL(18, 5) = 0
		DECLARE @TOTAL_ROUNDED_DURATION_TIME DECIMAL(18, 5) = 0
		DECLARE @TOTAL_VALID_REQUEST DECIMAL(18, 5) = 0
					
		-- RECUPERAMOS LOS VALORES TOTALES DE LOS ULTIMOS SIETE DIAS
		SELECT TOP 100 @TOTAL_AUDIOS = SUM(ASAVST.[TotalAudio]), 
				@TOTAL_DURATION_TIME = SUM(ASAVST.[DurationTime] + ASAVST.[AlreadyDurationTime]),
				@TOTAL_VALID_DURATION_TIME = SUM(CASE WHEN (ASAVST.[ValidDurationTime] + ASAVST.[AlreadyTranscribedDurationTime]) > 60 
												THEN (ASAVST.[ValidDurationTime] + ASAVST.[AlreadyTranscribedDurationTime])
												ELSE 60 END), 
				@TOTAL_ROUNDED_DURATION_TIME = SUM(CASE WHEN (ASAVST.[RoundedDurationTime] + ASAVST.[AlreadyTranscribedRoundedDurationTime]) > 60 
													THEN (ASAVST.[RoundedDurationTime] + ASAVST.[AlreadyTranscribedRoundedDurationTime]) 
													ELSE 60 END), 
				@TOTAL_VALID_REQUEST = SUM(CASE WHEN (ASAVDT.[TotalValidRequest] + ASAVDT.[TotalInvalidRequest]) < (ASAVST.[TotalAudio]) 
											THEN ASAVST.[TotalAudio] 
											ELSE (ASAVDT.[TotalValidRequest] + ASAVDT.[TotalInvalidRequest]) END)
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK) 
			INNER JOIN [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT (NOLOCK) 
				ON ASAVDT.[InstallationId] = ASAVST.[InstallationId]
					AND ASAVDT.[BatchId] = ASAVST.[BatchID]
					AND ASAVDT.[SystemService] = ASAVST.[SystemService]
			WHERE ASAVST.[InstallationId] = @InstallationId
				AND ASAVST.[VCC] = @VCC 
				AND ASAVST.[SystemService] = 'COGNITIVE_ANALYSIS'
				AND ASAVDT.[Description] = 'SUCCED'
				AND ASAVST.[CreatedDate] >= '2020-05-01T00:00:00Z'

		/*
		SELECT @TOTAL_AUDIOS 'audios', 
				@TOTAL_VALID_REQUEST 'requests', 
				@TOTAL_DURATION_TIME 'durationTime',
				@TOTAL_VALID_DURATION_TIME 'validTime', 
				@TOTAL_ROUNDED_DURATION_TIME 'roundedTime', 
				(60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_VALID_DURATION_TIME 'validTimeAverage',
				(60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_ROUNDED_DURATION_TIME 'roundedTimeAverage'
		*/
			
		-- VALIDAMOS QUE LOS VALORES SEAN VALIDOS
		IF @TOTAL_AUDIOS IS NULL OR @TOTAL_AUDIOS = 0 
			OR @TOTAL_DURATION_TIME IS NULL OR @TOTAL_DURATION_TIME = 0 
			OR @TOTAL_VALID_DURATION_TIME IS NULL OR @TOTAL_VALID_DURATION_TIME = 0 
			OR @TOTAL_ROUNDED_DURATION_TIME IS NULL OR @TOTAL_ROUNDED_DURATION_TIME = 0
			OR @TOTAL_VALID_REQUEST  IS NULL OR @TOTAL_VALID_REQUEST = 0
		BEGIN
			-- TOMAMOS EL VALOR POR DEFECTO (O VALOR BASE) PARA SEGUNDOS POR REQUEST
			SET @SECONDS_PER_REQUEST = 30

			-- TOMAMOS EL VALOR POR DEFECTO (O VALOR BASE) PARA REQUEST POR MINUTO
			SET @REQUEST_PER_MINUTE = 2
		END
		ELSE
		BEGIN
			-- CALCULAMOSEL VALOR PROMEDIO DE SEGUNDOS POR REQUEST SEGUN EL HISTORICO
			SET @SECONDS_PER_REQUEST = @TOTAL_DURATION_TIME / @TOTAL_VALID_REQUEST

			-- CALCULAMOS EL VALOR PROMEDIO DE REQUEST POR MINUTO SEGUN EL HISTORICO
			--SET @REQUEST_PER_MINUTE = CEILING ((60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_VALID_DURATION_TIME)
			SET @REQUEST_PER_MINUTE = (60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_VALID_DURATION_TIME
			--SET @REQUEST_PER_MINUTE = CEILING ((60.00 * @TOTAL_VALID_REQUEST) / @TOTAL_ROUNDED_DURATION_TIME)
		END

		-- INSERTAMOS EL NUEVO PROMEDIO DE REQUEST EN LA TABLA HISTORICA
		INSERT INTO [dbo].[CognitiveAnalysisHistory] 
			([InstallationId], [VCC], [AverageRequestPerMinute])
		VALUES (@InstallationId, @VCC, @REQUEST_PER_MINUTE)
		
		-- RECUPERAMOS EL VALOR DE REQUEST PROMEDIO POR MINUTO
		SELECT @SECONDS_PER_REQUEST 'CAASPR', 
				@REQUEST_PER_MINUTE 'CAARPM', 
				@COGNITIVE_ANALYSIS_BILLING_SECURE_RATE 'CABSR'

	END TRY
    BEGIN CATCH
        -- IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[ReportByVCCBalanceDetail]...';


GO
ALTER PROCEDURE [dbo].[ReportByVCCBalanceDetail] (
	@PlatformHash VARCHAR(100)=NULL,
	@StartDate DATETIME = NULL,
	@EndDate DATETIME = NULL,
	@InstallationId VARCHAR(100)=NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@UserApi VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL	
	)
AS
BEGIN
	-- ESTE PROCEDURE TIENE POR FINALIDAD HACER UN REPORTE DETALLADO DE TRANSACCIONES
	SET NOCOUNT ON

	-- EN CASO EL VCC SEA SYSTEM LO IGUALAMOS A NULL
	IF @VCC = 'system' SET @VCC = NULL

	SELECT
		D.[ClientId]													'COLUMN_CLIENT_NAME',
		S.[StartDate]													'COLUMN_START_DATE',
		S.[EndDate]														'COLUMN_END_DATE',
		D.[BatchTypeName]												'COLUMN_BATCH_TYPE_NAME',
		D.[BatchTypeId]													'COLUMN_BATCH_TYPE_ID',
		D.[AccountId]													'COLUMN_ACCOUNT',
		D.[SubAccountId]												'COLUMN_SUBACCOUNT',
		D.[ApiId]														'COLUMN_API_ID',
		D.[SystemService]												'COLUMN_SYSTEM_SERVICE',
		CASE WHEN D.[SystemService] = 'TRANSCRIPTION' 
			THEN SUM(ISNULL(D.[Rate], 0)) ELSE NULL END					'COLUMN_TRANSCRIPTION_TOTAL_RATE',
		D.[RatePerSecond]												'COLUMN_TRANSCRIPTION_RATE_PER_SECOND',
		SUM(ISNULL(D.[ValidDurationTime], 0))							'COLUMN_TRANSCRIPTION_VALID_DURATION_TIME',
		S.[SemanticAnalysisRatePerTransaction]							'COLUMN_SEMANTIC_ANALYSIS_RATE_PER_TRANSACTION',
		CASE WHEN S.[TotalQueries] > 0 THEN 1 ELSE NULL END				'COLUMN_SEMANTIC_ANALYSIS_TOTAL_REQUEST',
		CASE WHEN D.[SystemService] = 'SEMANTIC_ANALYSIS' 
			THEN SUM(ISNULL(D.[Rate], 0)) ELSE NULL END					'COLUMN_SEMANTIC_ANALYSIS_TOTAL_RATE',
		S.[CognitiveAnalysisRatePerTransaction]							'COLUMN_COGNITIVE_ANALYSIS_RATE_PER_TRANSACTION',
		CASE WHEN D.[SystemService] = 'COGNITIVE_ANALYSIS' 
			THEN SUM(D.[TotalValidRequest]) ELSE NULL END				'COLUMN_COGNITIVE_ANALYSIS_TOTAL_REQUEST',
		CASE WHEN D.[SystemService] = 'COGNITIVE_ANALYSIS' 
			THEN SUM(ISNULL(D.[Rate], 0)) ELSE NULL END					'COLUMN_COGNITIVE_ANALYSIS_TOTAL_RATE',
		D.[EntityId]													'COLUMN_ENTITY_ID'
	FROM AccountSubAccountVCCDetailedTransaction D (NOLOCK)
	LEFT JOIN AccountSubAccountVCCSummaryTransaction S (NOLOCK)
		ON S.BatchID = D.BatchId
			AND S.[SystemService] = D.[SystemService]
	WHERE D.[InstallationId] IS NOT NULL
		AND   (@InstallationId IS NULL OR D.[InstallationId] = @InstallationId)
		AND   (@StartDate IS NULL OR S.[EndDate] >= @StartDate)
		AND   (@EndDate IS NULL OR S.[EndDate] <= @EndDate)
		AND   (@BatchTypeName IS NULL OR D.[BatchTypeName] = @BatchTypeName)
		AND   (@BatchTypeId IS NULL OR D.[BatchTypeId] = @BatchTypeId)
		AND   (@AccountId IS NULL OR D.[AccountId] = @AccountId)
		AND   (
				((@SubAccountId IS NULL OR @SubAccountId = 'NONE') AND D.[SubAccountId] IS NULL)
				OR (@SubAccountId = 'ALL_SUBACCOUNTS' AND D.[SubAccountId] IS NOT NULL)
				OR D.[SubAccountId] = @SubAccountId
		)
		AND   (
				(@VCC IS NOT NULL AND D.[VCC] = @VCC)
				OR D.[VCC] IS NOT NULL
			)
		AND   (@UserApi IS NULL OR S.[UserApi] = @UserApi)
	GROUP BY D.[ClientId], S.[StartDate], S.[EndDate], D.[BatchTypeName], D.[BatchTypeId], 
		D.[AccountId], D.[SubAccountId], D.[ApiId], D.[SystemService], D.[RatePerSecond], 
		S.[SemanticAnalysisRatePerTransaction], S.[TotalQueries], S.[CognitiveAnalysisRatePerTransaction], S.[TotalModelRequest], D.[EntityId]

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[ReportSummaryofExpensesbyPeriod]...';


GO
ALTER Procedure [dbo].[ReportSummaryofExpensesbyPeriod] (
	@StartDate DATETIME = NULL,
	@EndDate DATETIME = NULL,
	@InstallationId Varchar(150),
	@AccountId Varchar(150)  = NULL,
	@SubAccountId Varchar(150)  = NULL,
	@VCC Varchar(150)  = NULL,
	@Slice Int = 1
) As
BEGIN 
	-- EN CASO EL VALOR DE VCC LEGUE COMO SYSTEM LO IGUALAMOS A NULL
	IF @VCC = 'system' SET @VCC = NULL

	SELECT 
	  case @Slice
		when 1 then Dateadd(DAY,datediff(DAY, 0, A.enddate), 0)
		when 30 then Dateadd(MONTH,datediff(MONTH, 0, A.enddate), 0)
		else Dateadd(DAY,datediff(DAY, 0, A.enddate), 0)
	  end AS 'COLUMN_SLICE',
	  --Dateadd(day, 0, @Slice * Floor(Datediff(day, 0, A.enddate) / @Slice)) AS SLICE, 
	  A.systemservice AS 'COLUMN_BATCH_TYPE_NAME', 
	  Avg(A.TranscriptionRatePerSecond)  AS 'COLUMN_TRANSCRIPTION_RATE_PER_SECOND', 
	  avg(A.SemanticAnalysisRatePerTransaction)  AS 'COLUMN_SEMANTIC_ANALYSIS_RATE_PER_TRANSACTION', 
	  avg(A.CognitiveAnalysisRatePerTransaction)  AS 'COLUMN_COGNITIVE_ANALYSIS_RATE_PER_TRANSACTION', 
	  A.installationid AS 'COLUMN_PLATFORM', 
	  B.accountid AS 'COLUMN_ACCOUNT', 
	  B.subaccountid AS 'COLUMN_SUBACCOUNT', 
	  A.vcc AS 'COLUMN_VCC', 
	  Sum(CASE WHEN A.[SystemService] = 'TRANSCRIPTION' THEN ISNULL(A.[ValidDurationTime], 0) ELSE 0 END) AS 'COLUMN_TRANSCRIPTION_VALID_DURATION_TIME', 
	  -- Sum(A.Totalqueries) AS CANTIDADAS, 
	  Sum(A.TotalQueryRequest) AS 'COLUMN_SEMANTIC_ANALYSIS_TOTAL_REQUEST', 
	  Sum(A.totalmodelrequest) AS 'COLUMN_COGNITIVE_ANALYSIS_TOTAL_REQUEST', 
	  --Sum(A.Rate) As Rate, 
	  SUM(CASE WHEN A.[SystemService] = 'TRANSCRIPTION' THEN ISNULL(A.[Rate], 0) ELSE 0 END) AS 'COLUMN_TRANSCRIPTION_TOTAL_RATE', 
	  SUM(CASE WHEN A.[SystemService] = 'SEMANTIC_ANALYSIS' THEN ISNULL(A.[Rate], 0) ELSE 0 END) AS 'COLUMN_SEMANTIC_ANALYSIS_TOTAL_RATE', 
	  SUM(CASE WHEN A.[SystemService] = 'COGNITIVE_ANALYSIS' THEN ISNULL(A.[Rate], 0) ELSE 0 END) AS 'COLUMN_COGNITIVE_ANALYSIS_TOTAL_RATE' 
	  /*
	  Sum(A.transcriptionratepersecond) * Sum(CASE WHEN A.[SystemService] = 'TRANSCRIPTION' THEN ISNULL(A.[ValidDurationTime], 0) ELSE 0 END) AS TOTALTR, 
	  Sum(A.semanticanalysisratepertransaction) * Sum(A.validtotalqueries) AS TOTALAS, 
	  Sum(A.cognitiveanalysisratepertransaction) * Sum(A.totalmodelrequest) AS TOTALAC */
	FROM accountsubaccountvccsummarytransaction (nolock) AS A 
	LEFT JOIN accountvcc (nolock) AS B 
		ON A.installationid = B.installationid 
			AND A.vcc = B.vcc 
	WHERE A.installationid = @InstallationId 
		AND A.enddate BETWEEN @StartDate 
		AND @EndDate 
		AND B.accountid LIKE CASE WHEN @AccountId IS NOT NULL THEN @AccountId ELSE B.accountid END 
		AND   (
			((@SubAccountId IS NULL OR @SubAccountId = 'NONE') AND B.[SubAccountId] IS NULL)
			OR (@SubAccountId = 'ALL_SUBACCOUNTS' AND B.[SubAccountId] IS NOT NULL)
			OR B.[SubAccountId] = @SubAccountId
		)
		AND   (
			(@VCC IS NOT NULL AND A.[VCC] = @VCC)
			OR A.[VCC] IS NOT NULL
		)
		--AND A.vcc LIKE CASE WHEN @VCC IS NOT NULL THEN @VCC ELSE A.vcc END -- 
	GROUP BY 
	  case @Slice
		when 1 then Dateadd(DAY,datediff(DAY, 0, A.enddate), 0)
		when 30 then Dateadd(MONTH,datediff(MONTH, 0, A.enddate), 0)
		else Dateadd(DAY,datediff(DAY, 0, A.enddate), 0)
	  end,
	  --Dateadd(DAY,datediff(DAY, 0, A.enddate), 0),
	  --Dateadd(day, 0, @Slice * Floor(Datediff(day, 0, A.enddate) / @Slice)), 
	  A.vcc, 
	  A.systemservice, 
	  B.accountid, 
	  B.subaccountid, 
	  A.installationid

END
GO
PRINT N'Altering [dbo].[GetInstallationIds]...';


GO

ALTER PROCEDURE [dbo].[GetInstallationIds]
(@InstallationId VARCHAR(100) = NULL)
AS
BEGIN
	SET NOCOUNT ON

	/*
	SELECT DISTINCT A.[InstallationId]				'installationId',
		A.[AccountId]								'accountId',
		A.[SubAccountId]							'subAccountId',
		AV.[VCC]									'vcc',
		UA.[UserApi]								'apiUser'
	FROM [dbo].[Account] A (NOLOCK)
	LEFT JOIN [dbo].[AccountVCC] AV (NOLOCK)
		ON AV.[InstallationId] = A.[InstallationId] 
			AND AV.[AccountId] = A.[AccountId]
			AND AV.[SubAccountId] = CASE WHEN A.[SubAccountId] IS NOT NULL THEN A.[SubAccountId] ELSE AV.[SubAccountId] END
	LEFT JOIN [UserApi] UA (NOLOCK)
		ON UA.[InstallationId] = A.[InstallationId]
			AND UA.[VCC] = AV.[VCC]
	WHERE A.[InstallationId] IS NOT NULL
		AND   (@InstallationId IS NULL OR A.[InstallationId] = @InstallationId)
	ORDER BY A.[AccountId] ASC
	*/
	
	SELECT
		DISTINCT P.[InstallationId]				'installationId',
		AV.[VCC]								'vcc',
		U.[UserApi]								'apiUser',
		AV.[AccountId]							'accountId',
		A.[SubAccountId]						'subAccountId'
	FROM [dbo].[Platform] P (NOLOCK)
	LEFT JOIN [dbo].[Account] A (NOLOCK) 
		ON A.[InstallationId] = P.[InstallationId]
	LEFT JOIN  [dbo].[AccountVCC] AV (NOLOCK)
		ON AV.[InstallationId] = P.[InstallationId]
			AND AV.[AccountId] = A.[AccountId]
			AND ((AV.[SubAccountId] IS NULL AND A.[SubAccountId] IS NULL) OR (AV.[SubAccountId] = A.[SubAccountId]))
	LEFT JOIN [dbo].[UserApi] U  (NOLOCK)
		ON A.[InstallationId] = U.[InstallationId]
		AND U.[VCC] = AV.[VCC]
	WHERE P.[InstallationId] IS NOT NULL
		AND (@InstallationId IS NULL OR P.[InstallationId] = @InstallationId)

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[ReportByAccountSubAccountAvailableBalanceDetail]...';


GO
ALTER PROCEDURE [dbo].[ReportByAccountSubAccountAvailableBalanceDetail] (
	@PlatformHash VARCHAR(100)=NULL,
	-- @StartDate DATETIME = NULL,
	-- @EndDate DATETIME = NULL,
	@InstallationId VARCHAR(100)=NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	-- @MinAvailableBalance INT = NULL,
	@MaxAvailableBalance INT = NULL
	)
AS
BEGIN
	-- ESTE PROCEDURE TIENE POR FINALIDAD RETORNAR EL REPORTE DE RECARGA DE SALDOS
	SET NOCOUNT ON

	-- EN CASO MAXAVAILABLEBALANCE LLEGUE VACIO LO IGUALAMOS A NULL PARA QUE NO SEA CONSIDERADO
	IF @MaxAvailableBalance = '' SET @MaxAvailableBalance = NULL
	-- IF @MinAvailableBalance = '' SET @MinAvailableBalance = NULL

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- VALIDAMOS SI SUBCUENTA ES NULL
		IF @SubAccountId IS NULL
		BEGIN
			-- PARA EL CASO CUANDO SUBACCOUNTID ES NULL

			-- DECLARAMOS LAS CTE QUE JUNTARAN LA DATA REQUERIDA PARA EL REPORTE
			WITH CTE_AVAILABLE_BALANCE_REPORT AS (
				-- EL PRIMER SELECT RECUPERA EL SALDO PROPIO DE LA CUENTA (DONDE SUBACCOUNTID = NULL)
				SELECT AB.[InstallationId]											'COLUMN_PLATFORM',
						AB.[AccountId]												'COLUMN_ACCOUNT',
						NULL														'COLUMN_SUBACCOUNT',
						SUM(AB.[AvailableBalance])									'COLUMN_AVAILABLE_BALANCE',
						STUFF((SELECT ', ' + AV.[VCC]
								FROM [dbo].[AccountVCC] AV (NOLOCK)
								WHERE AV.[InstallationId] = AB.[InstallationId]
									AND AV.[AccountId] = AB.[AccountId]
								ORDER BY AV.[VCC]
								FOR XML PATH('')), 1, 1, '' ) AS					'COLUMN_RELATED_VCCS',
						(SELECT MAX(ASAVBM.[TimeStamp])	
							FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK) 
							WHERE ASAVBM.[InstallationId] = AB.[InstallationId]
								AND ASAVBM.[AccountId] = AB.[AccountId]
								AND ASAVBM.[SubAccountId] IS NULL 
								AND ASAVBM.[VCC]  IS NULL 
								AND ASAVBM.[Wallet] = 'FREE'
								AND ASAVBM.[Type] = 'CHARGE')						'COLUMN_LAST_RECHARGE_DATE'
					FROM [dbo].[AccountBalance] AB (NOLOCK)
					WHERE (@InstallationId IS NULL OR AB.[InstallationId] = @InstallationId)
						AND (@AccountId IS NULL OR AB.[AccountId] = @AccountId)
					GROUP BY AB.[InstallationId], AB.[AccountId]
				UNION
				-- EL SEGUNDO SELECT RECUPERA EL SALDO YA ASIGNADO A LAS SUBCUENTAS Y VCC DE LA CUENTA
				SELECT AVB.[InstallationId]											'COLUMN_PLATFORM',
						AVB.[AccountId]												'COLUMN_ACCOUNT',
						NULL														'COLUMN_SUBACCOUNT',
						SUM(AVB.[CountableBalance])									'COLUMN_AVAILABLE_BALANCE',
						STUFF((SELECT ', ' + AV.[VCC]
								FROM [dbo].[AccountVCC] AV (NOLOCK)
								WHERE AV.[InstallationId] = AVB.[InstallationId]
									AND AV.[AccountId] = AVB.[AccountId]
								ORDER BY AV.[VCC]
								FOR XML PATH('')), 1, 1, '' ) AS					'COLUMN_RELATED_VCCS',
						(SELECT MAX(ASAVBM.[TimeStamp])	
							FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK) 
							WHERE ASAVBM.[InstallationId] = AVB.[InstallationId]
								AND ASAVBM.[AccountId] = AVB.[AccountId]
								AND ASAVBM.[SubAccountId] IS NULL 
								AND ASAVBM.[VCC]  IS NULL 
								AND ASAVBM.[Wallet] = 'FREE'
								AND ASAVBM.[Type] = 'CHARGE')						'COLUMN_LAST_RECHARGE_DATE'
					FROM [dbo].[AccountVCCBalance] AVB (NOLOCK) 
					WHERE (@InstallationId IS NULL OR AVB.[InstallationId] = @InstallationId)
						AND (@AccountId IS NULL OR AVB.[AccountId] = @AccountId)
					GROUP BY AVB.[InstallationId], AVB.[AccountId] 
				UNION
				-- EL TERCER SELECT RECUPERA EL SALDO PROPIO DE LAS SUBCUENTAS
				SELECT AB.[InstallationId]											'COLUMN_PLATFORM',
						AB.[AccountId]												'COLUMN_ACCOUNT',
						AB.[SubAccountId]											'COLUMN_SUBACCOUNT',
						SUM(AB.[AvailableBalance])									'COLUMN_AVAILABLE_BALANCE',
						STUFF((SELECT ', ' + AV.[VCC]
								FROM [dbo].[AccountVCC] AV (NOLOCK)
								WHERE AV.[InstallationId] = AB.[InstallationId]
									AND AV.[AccountId] = AB.[AccountId]
									AND AV.[SubAccountId] = AB.[SubAccountId]
								ORDER BY AV.[VCC]
								FOR XML PATH('')), 1, 1, '' ) AS					'COLUMN_RELATED_VCCS',
						(SELECT MAX(ASAVBM.[TimeStamp])	
							FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK) 
							WHERE ASAVBM.[InstallationId] = AB.[InstallationId]
								AND ASAVBM.[AccountId] = AB.[AccountId]
								AND ASAVBM.[SubAccountId] = AB.[SubAccountId]
								AND ASAVBM.[VCC]  IS NULL 
								AND ASAVBM.[Wallet] = 'FREE'
								AND ASAVBM.[Type] = 'CHARGE')						'COLUMN_LAST_RECHARGE_DATE'
					FROM [dbo].[AccountBalance] AB (NOLOCK)
					WHERE (@InstallationId IS NULL OR AB.[InstallationId] = @InstallationId)
						AND (@AccountId IS NULL OR AB.[AccountId] = @AccountId)
						AND AB.[SubAccountId] IS NOT NULL
					GROUP BY AB.[InstallationId], AB.[AccountId], AB.[SubAccountId]
				UNION
				-- EL CUARTO SELECT RECUPERA EL SALDO YA ASIGNADO A LOS VCC DE LAS SUBCUENTAS
				SELECT AVB.[InstallationId]											'COLUMN_PLATFORM',
						AVB.[AccountId]												'COLUMN_ACCOUNT',
						AVB.[SubAccountId]											'COLUMN_SUBACCOUNT',
						SUM(AVB.[CountableBalance])									'COLUMN_AVAILABLE_BALANCE',
						STUFF((SELECT ', ' + AV.[VCC]
								FROM [dbo].[AccountVCC] AV (NOLOCK)
								WHERE AV.[InstallationId] = AVB.[InstallationId]
									AND AV.[AccountId] = AVB.[AccountId]
									AND AV.[SubAccountID] = AVB.[SubAccountId]
								ORDER BY AV.[VCC]
								FOR XML PATH('')), 1, 1, '' ) AS					'COLUMN_RELATED_VCCS',
						(SELECT MAX(ASAVBM.[TimeStamp])	
							FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK) 
							WHERE ASAVBM.[InstallationId] = AVB.[InstallationId]
								AND ASAVBM.[AccountId] = AVB.[AccountId]
								AND ASAVBM.[SubAccountId] = AVB.[SubAccountId]
								AND ASAVBM.[VCC]  IS NULL 
								AND ASAVBM.[Wallet] = 'FREE'
								AND ASAVBM.[Type] = 'CHARGE')						'COLUMN_LAST_RECHARGE_DATE'
					FROM [dbo].[AccountVCCBalance] AVB (NOLOCK) 
					WHERE (@InstallationId IS NULL OR AVB.[InstallationId] = @InstallationId)
						AND (@AccountId IS NULL OR AVB.[AccountId] = @AccountId)
						AND AVB.[SubAccountId] IS NOT NULL
					GROUP BY AVB.[InstallationId], AVB.[AccountId], AVB.[SubAccountId]
			),
			CTE_AVAILABLE_BALANCE_REPORT_2 AS (
				SELECT CTEABR.[COLUMN_PLATFORM],
						CTEABR.[COLUMN_ACCOUNT],
						CTEABR.[COLUMN_SUBACCOUNT],
						SUM(CTEABR.[COLUMN_AVAILABLE_BALANCE]) 'COLUMN_AVAILABLE_BALANCE',
						CTEABR.[COLUMN_RELATED_VCCS],
						CTEABR.[COLUMN_LAST_RECHARGE_DATE]
					FROM CTE_AVAILABLE_BALANCE_REPORT CTEABR
					GROUP BY CTEABR.[COLUMN_PLATFORM], CTEABR.[COLUMN_ACCOUNT], CTEABR.[COLUMN_SUBACCOUNT], CTEABR.[COLUMN_RELATED_VCCS], CTEABR.[COLUMN_LAST_RECHARGE_DATE]
			)

			SELECT *
				FROM CTE_AVAILABLE_BALANCE_REPORT_2 CTEABR2
				WHERE (@MaxAvailableBalance IS NULL OR CTEABR2.[COLUMN_AVAILABLE_BALANCE] <= @MaxAvailableBalance)
				ORDER BY CTEABR2.[COLUMN_ACCOUNT], CTEABR2.[COLUMN_SUBACCOUNT], CTEABR2.[COLUMN_LAST_RECHARGE_DATE]

		END
		ELSE
		BEGIN
			-- PARA EL CASO CUANDO SUBACCOUNTID ES DIFERENTE DE NULL
			WITH CTE_AVAILABLE_BALANCE_REPORT AS (
				-- EL PRIMER SELECT RECUPERA EL SALDO PROPIO DE LAS SUBCUENTAS
				SELECT AB.[InstallationId]											'COLUMN_PLATFORM',
						AB.[AccountId]												'COLUMN_ACCOUNT',
						AB.[SubAccountId]											'COLUMN_SUBACCOUNT',
						SUM(AB.[AvailableBalance])									'COLUMN_AVAILABLE_BALANCE',
						STUFF((SELECT ', ' + AV.[VCC]
								FROM [dbo].[AccountVCC] AV (NOLOCK)
								WHERE AV.[InstallationId] = AB.[InstallationId]
									AND AV.[AccountId] = AB.[AccountId]
									AND AV.[SubAccountId] = AB.[SubAccountId]
								ORDER BY AV.[VCC]
								FOR XML PATH('')), 1, 1, '' ) AS					'COLUMN_RELATED_VCCS',
						(SELECT MAX(ASAVBM.[TimeStamp])	
							FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK) 
							WHERE ASAVBM.[InstallationId] = AB.[InstallationId]
								AND ASAVBM.[AccountId] = AB.[AccountId]
								AND ASAVBM.[SubAccountId] = AB.[SubAccountId]
								AND ASAVBM.[VCC]  IS NULL 
								AND ASAVBM.[Wallet] = 'FREE'
								AND ASAVBM.[Type] = 'CHARGE')						'COLUMN_LAST_RECHARGE_DATE'
					FROM [dbo].[AccountBalance] AB (NOLOCK)
					WHERE AB.[InstallationId] = @InstallationId
						AND (@AccountId IS NULL OR AB.[AccountId] = @AccountId)
						AND AB.[SubAccountId] = @SubAccountId
					GROUP BY AB.[InstallationId], AB.[AccountId], AB.[SubAccountId]
				UNION
				-- EL SEGUNDO SELECT RECUPERA EL SALDO YA ASIGNADO A LOS VCC DE LAS SUBCUENTAS
				SELECT AVB.[InstallationId]											'COLUMN_PLATFORM',
						AVB.[AccountId]												'COLUMN_ACCOUNT',
						AVB.[SubAccountId]											'COLUMN_SUBACCOUNT',
						SUM(AVB.[CountableBalance])									'COLUMN_AVAILABLE_BALANCE',
						STUFF((SELECT ', ' + AV.[VCC]
								FROM [dbo].[AccountVCC] AV (NOLOCK)
								WHERE AV.[InstallationId] = AVB.[InstallationId]
									AND AV.[AccountId] = AVB.[AccountId]
									AND AV.[SubAccountID] = AVB.[SubAccountId]
								ORDER BY AV.[VCC]
								FOR XML PATH('')), 1, 1, '' ) AS					'COLUMN_RELATED_VCCS',
						(SELECT MAX(ASAVBM.[TimeStamp])	
							FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK) 
							WHERE ASAVBM.[InstallationId] = AVB.[InstallationId]
								AND ASAVBM.[AccountId] = AVB.[AccountId]
								AND ASAVBM.[SubAccountId] = AVB.[SubAccountId]
								AND ASAVBM.[VCC]  IS NULL 
								AND ASAVBM.[Wallet] = 'FREE'
								AND ASAVBM.[Type] = 'CHARGE')						'COLUMN_LAST_RECHARGE_DATE'
					FROM [dbo].[AccountVCCBalance] AVB (NOLOCK) 
					WHERE AVB.[InstallationId] = @InstallationId
						AND (@AccountId IS NULL OR AVB.[AccountId] = @AccountId)
						AND AVB.[SubAccountId] = @SubAccountId
					GROUP BY AVB.[InstallationId], AVB.[AccountId], AVB.[SubAccountId]
			),
			CTE_AVAILABLE_BALANCE_REPORT_2 AS (
				SELECT CTEABR.[COLUMN_PLATFORM],
						CTEABR.[COLUMN_ACCOUNT],
						CTEABR.[COLUMN_SUBACCOUNT],
						SUM(CTEABR.[COLUMN_AVAILABLE_BALANCE]) 'COLUMN_AVAILABLE_BALANCE',
						CTEABR.[COLUMN_RELATED_VCCS],
						CTEABR.[COLUMN_LAST_RECHARGE_DATE]
					FROM CTE_AVAILABLE_BALANCE_REPORT CTEABR
					GROUP BY CTEABR.[COLUMN_PLATFORM], CTEABR.[COLUMN_ACCOUNT], CTEABR.[COLUMN_SUBACCOUNT], CTEABR.[COLUMN_RELATED_VCCS], CTEABR.[COLUMN_LAST_RECHARGE_DATE]
			)

			SELECT CTEABR2.[COLUMN_PLATFORM],
						CTEABR2.[COLUMN_ACCOUNT],
						CTEABR2.[COLUMN_SUBACCOUNT],
						CTEABR2.[COLUMN_AVAILABLE_BALANCE],
						CTEABR2.[COLUMN_RELATED_VCCS],
						CTEABR2.[COLUMN_LAST_RECHARGE_DATE]
				FROM CTE_AVAILABLE_BALANCE_REPORT_2 CTEABR2
				WHERE (@MaxAvailableBalance IS NULL OR CTEABR2.[COLUMN_AVAILABLE_BALANCE] <= @MaxAvailableBalance)
				ORDER BY CTEABR2.[COLUMN_LAST_RECHARGE_DATE]
					
		END

	END TRY
    BEGIN CATCH
        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1

    END CATCH

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[AccountSubAccountVCCBatchSummaryCreate]...';


GO

ALTER PROCEDURE [dbo].[AccountSubAccountVCCBatchSummaryCreate] (
	@PlatformHash VARCHAR(100) = NULL,
	@InstallationId VARCHAR(50) = NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@TotalAudio int = 0,								-- CANTIDAD DE AUDIOS DEL PRESENTE BATCH
	@DurationTime int = 0,								-- TIEMPO BRUTO DE LOS AUDIOS DEL PRESENTE BATCH
	@RoundedDurationTime int = 0,						-- TIEMPO REDONDEADO BRUTO DE LOS AUDIOS DEL PRESENTE BATCH
	@InProcessAudio int = 0,							-- CANTIDAD DE AUDIOS YA PRESENTES EN OTROS BATCH
	@InProcessDurationTime int = 0,						-- TIEMPO BRUTO DE LOS AUDIOS YA PRESENTES EN OTROS BATCH
	@AlreadyTranscribedAudio int = 0,					-- CANTIDAD DE AUDIOS YA TRANSCRITOS EN OTROS BATCH
	@AlreadyDurationTime int = 0,						-- TIEMPO BRUTO YA TRANSCRITO
	@AlreadyRoundedDurationTime int = 0,				-- TIEMPO REDODNEADO BRUTO YA TRANSCRITO
	@AlreadyTranscribedDurationTime int = 0,			-- TIEMPO TRANCRITO
	@AlreadyTranscribedRoundedDurationTime int = 0,		-- TIEMPO REDONDEADO YA TRANSCRITO
	@TotalQueries int = 0,
	@TotalModels int = 0,
	@ModelRequests DECIMAL(18, 5) = 0,					-- CANTIDAD ESTIMADA DE REQUESTS POR MODELO
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL,
	@ProcessId VARCHAR(100) = NULL,
	@TemplateId VARCHAR(100) = NULL,
	@UserApi VARCHAR(50) = NULL,
	@StartDate DateTime = NULL
) AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
		IF @PlatformHash IS NULL 
			OR @InstallationId IS NULL 
			OR @AccountId IS NULL 
			OR @VCC IS NULL
			OR @UserApi IS NULL
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		-- TOCA VALIDAR QUE EXISTE EL PLATFORMHASH Y ESTA ACTIVO
		-- TOCA VALIDAR QUE EXISTE EL ACCOUNT
		-- TOCA VALIDAR QUE EXISTE EL SUBACCOUNT
		-- TOCA VALIDAR QUE EXISTE EL VCC
		-- TOCA VALIDAD QUE EXISTE EL USERAPI

		-- VERIFICAMOS QUE EL BATCH TYPE SEA UN TIPO CONOCIDO DEL SISTEMA
		IF @BatchTypeName <> 'EVALUATION_PLAN' AND @BatchTypeName <> 'TRANSCRIPTION' AND @BatchTypeName <> 'STUDY'
			-- LANZAMOS MENSAJE AVISANDO QUE HAN SOLICITADO UNA OPERACION DESCONOCIDA
			RAISERROR('DATABABASE_ERROR_UNKNOWN_BATCH_TYPE', 16, 16)

		-- VERIFICAMOS QUE EL BATCH RECIBIDO NO EXISTA YA EN LA BASE DE DATOS
		IF EXISTS(
			SELECT ASAVST.[BatchTypeId] 
				FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
				WHERE ASAVST.[InstallationId] = @InstallationId
					AND ASAVST.[VCC] =  @VCC
					AND ASAVST.[BatchTypeName] = @BatchTypeName
					AND ASAVST.[BatchTypeId] =  @BatchTypeId
		)
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABABASE_ERROR_DUPLICATE_BATCHTYPEID', 16, 16)
		
		-- DECLARAMOS VARIABLES TIPO BIT QUE NOS INDIQUEN LOS SERVICIOS DEL SISTEMA QUE REGISTRAREMOS
		DECLARE @TRANSCRIPTION BIT = 0
		DECLARE @SEMANTIC_ANALYSIS BIT = 0
		DECLARE @COGNITIVE_ANALYSIS BIT = 0
		DECLARE @VALID_DURATION_TIME INT = 0
		DECLARE @ROUNDED_VALID_DURATION_TIME INT = 0

		-- SEGUN LOS DATOS RECIBIDOS DETERMINAMOS QUE SERVICIO DEL SISTEMA ESTA INCLUIDO EN EL BATCH
		IF @DurationTime > 0 SET @TRANSCRIPTION = 1
		IF @TotalQueries > 0 SET @SEMANTIC_ANALYSIS = 1
		IF @TotalModels > 0 SET @COGNITIVE_ANALYSIS = 1

		-- VALIDAMOS QUE AL MENOS UNO DE LOS SERVICIOS DEL SISTEMA SEA CONSUMIDO PRO EL BATCH
		IF @TRANSCRIPTION = 0 AND @SEMANTIC_ANALYSIS = 0 AND @COGNITIVE_ANALYSIS = 0
			-- LANZAMOS MENSAJE AVISANDO QUE HAN SOLICITADO UNA OPERACION DESCONOCIDA
			RAISERROR('DATABABASE_ERROR_NO_SYSTEM_SERVICE', 16, 16)

		-- DECLARAMOS VARIABLES TIPO DECIMAL PARA ALMACENAR LAS TARIFAS DE SERVICIOS SETTEADAS PARA EL VCC
		DECLARE @TRANSCRIPTION_RATE_PER_SECOND DECIMAL(18,5) = 0
		DECLARE @SEMANTIC_ANALYSIS_RATE_PER_SECOND DECIMAL(18,5) = 0
		DECLARE @COGNITIVE_ANALYSIS_RATE_PER_SECOND DECIMAL(18,5) = 0

		-- BUSCAMOS LA TARIFAS DE LOS SERVICIOS DEL SISTEMA PARA EL VCC INGRESADO
		SELECT @TRANSCRIPTION_RATE_PER_SECOND = AV.[TranscriptionRatePerSecond],
				@SEMANTIC_ANALYSIS_RATE_PER_SECOND = AV.[SemanticAnalysisRatePerTransaction],
				@COGNITIVE_ANALYSIS_RATE_PER_SECOND = AV.[CognitiveAnalysisRatePerTransaction]
			FROM [dbo].[AccountVCC] AV (NOLOCK)
			WHERE AV.[InstallationId] = @InstallationId
				AND AV.[VCC] = @VCC 

		-- DECLARAMOS UNA VARIABLE PARA EL IDENTIFICADOR UNICO DEL BATCH
		DECLARE @ID VARCHAR(100) = NEWID()

		-- DECLARAMOS UNA VARIABLE INT PARA CONTABILIZAR LOS PASOS PARA EL REGISTRO DE MOVIMIENTOS
		DECLARE @BATCH_TOTAL_STEPS INT = 0

		-- DECLARAMOS UNA VARIABLE PARA INDICAR EL PASO ACTUAL EN QUE NOS ENCONTRAMOS
		DECLARE @BATCH_CURRENT_STEP INT = 0 

		-- DECLARAMOS UNA VARIABLE VARCHAR PARA CONCATENAR LOS SERVICIOS DEL SISTEMA INCLUIDOS EN EL BATCH
		DECLARE @BATCH_SYSTEM_SERVICES VARCHAR(100) = ''
		
		-- CONCATENAMOS LOS SERVICIOS DEL SISTEMA Y ACUMULMOS EL TOTAL DE PASOS PARA EL REGISTRO DE MOVIMIENTOS (SERVICIOS ASOCIADOS * 3 <- RETAIN, DEBT, RELEASE)
		IF @TRANSCRIPTION = 1
		BEGIN
			SET @BATCH_TOTAL_STEPS = @BATCH_TOTAL_STEPS + (1 * 3)
			SET @BATCH_SYSTEM_SERVICES = CONCAT(@BATCH_SYSTEM_SERVICES, 'TRANSCRIPTION,')
		END

		IF @SEMANTIC_ANALYSIS = 1 
		BEGIN 
			SET @BATCH_TOTAL_STEPS = @BATCH_TOTAL_STEPS + (1 * 3)
			SET @BATCH_SYSTEM_SERVICES = CONCAT(@BATCH_SYSTEM_SERVICES, 'SEMANTIC_ANALYSIS,')
		END
		
		IF @COGNITIVE_ANALYSIS = 1 
		BEGIN 
			SET @BATCH_TOTAL_STEPS = @BATCH_TOTAL_STEPS + (1 * 3)
			SET @BATCH_SYSTEM_SERVICES = CONCAT(@BATCH_SYSTEM_SERVICES, 'COGNITIVE_ANALYSIS,')
		END

		-- DECLARAMOS LA VARIABLE EN LA QUE ESCRIBIREMOS LA DESCRIPCION DEL MOVIMIENTO
		DECLARE @MOVEMENT_DESCRIPTION VARCHAR(250) = NULL

		-- DECLARAMOS UNA VARIABLE VARCHAR PARA ALMACENAR EL SERVICIO DEL SISTEMA RECORRIDO
		DECLARE @CURRENT_SYSTEM_SERVICE VARCHAR(50) = ''

		-- DECLARAMOS UNA VARIABLE DECIMAL PARA ALMACENAR EL SALDO RETENIDO RECORRIDO
		DECLARE @CURRENT_RETAINED_AMOUNT DECIMAL(18,5) = 0

		-- DECLARAMOS UNA VARIABLE DECIMAL PARA ALMACENAR EL TOTAL DE REQUEST ESTIMADOS CON % DE SEGURIDAD INCLUIDO
		DECLARE @CURRENT_TOTAL_ESTIMATED_MODEL_REQUESTS DECIMAL(18,5) = 0
		
		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL SPLIT DE SERVICIOS
		DECLARE MY_CURSOR CURSOR 
		LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
			SELECT Value FROM [dbo].[split](@BATCH_SYSTEM_SERVICES, ',')

		-- ABRIMOS Y RECORREMOS EL ARRAY DE PRODUCTOS
		OPEN MY_CURSOR
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_SYSTEM_SERVICE
		WHILE @@FETCH_STATUS = 0
		BEGIN 
			-- VALIDAMOS QUE NO SEA UNA VARIABLE VACIA
			IF @CURRENT_SYSTEM_SERVICE <> ''
			BEGIN
				-- SETTEAMOS EL MONTO RETENIDO ACTUAL
				IF @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION' SET @CURRENT_RETAINED_AMOUNT = @TRANSCRIPTION_RATE_PER_SECOND * (@DurationTime - @InProcessDurationTime - @AlreadyDurationTime)
				IF @CURRENT_SYSTEM_SERVICE IN ('SEMANTIC_ANALYSIS', 'COGNITIVE_ANALYSIS')
				BEGIN
					-- DEPENDIENDO DEL TIPO DE BATCH TOMAMOS EL TIEMPO DE DIFERENTE FORMA
					IF @BatchTypeName = 'STUDY'
					BEGIN
						-- RECUPERAMOS EL DURATIONTIME USANDO EL PROCESSID
						SELECT @TotalAudio = (ASAVST.[ValidTotalAudio] + ASAVST.[AlreadyTranscribedAudio]),
								@DurationTime = (ASAVST.[DurationTime] + ASAVST.[AlreadyDurationTime]),
								@VALID_DURATION_TIME = (ASAVST.[ValidDurationTime] + ASAVST.[AlreadyTranscribedDurationTime]),
								@ROUNDED_VALID_DURATION_TIME = (ASAVST.[RoundedDurationTime] + ASAVST.[AlreadyTranscribedRoundedDurationTime])
							FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK) 
							WHERE ASAVST.[InstallationId] = @InstallationId
								AND ASAVST.[VCC] = @Vcc
								AND ASAVST.[BatchTypeName] = 'TRANSCRIPTION'
								AND ASAVST.[BatchTypeID] = @ProcessId

						-- SI ESTAMOS CREANDO ESTUDIO, NO NECESITAMOS EL DURATIONTIME PORQUE YA TENEMOS EL VALIDDURATIONTIME
					END
					ELSE IF @BatchTypeName = 'EVALUATION_PLAN'
					BEGIN 
						SET @DurationTime = @DurationTime
						SET @ROUNDED_VALID_DURATION_TIME = @RoundedDurationTime
						SET @AlreadyDurationTime = @AlreadyDurationTime
						SET @AlreadyRoundedDurationTime = @AlreadyRoundedDurationTime
					END

					IF @CURRENT_SYSTEM_SERVICE = 'SEMANTIC_ANALYSIS' SET @CURRENT_RETAINED_AMOUNT = @SEMANTIC_ANALYSIS_RATE_PER_SECOND * @TotalQueries

					IF @CURRENT_SYSTEM_SERVICE = 'COGNITIVE_ANALYSIS'
					BEGIN
						-- DECLARAMOS UNA TABLE PARA ALMACENAR EL RESULTADO DEL SP
						DECLARE @SP_RESULT AS TABLE ([CAASPR] DECIMAL(5, 2), [CAARPM] DECIMAL(5, 2), [CABSR] DECIMAL(5, 2))

						-- EJECUTAMOS EL SP QUE GENERA EL NUMERO DE REQUEST PROMEDIO POR MINUTO
						INSERT @SP_RESULT EXEC [dbo].[GetCognitiveAnalysisAverageRequestPerMinute] @InstallationId, @Vcc 
						--EXEC [dbo].[GetCognitiveAnalysisAverageRequestPerMinute] @InstallationId, @Vcc 

						DECLARE @AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST DECIMAL(5, 2) = 0
						DECLARE @AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE DECIMAL(5, 2) = 0
						-- *TASA DE SEGURO DE FACTURACION: SI SE CAMBIA ESTE VALOR, SE DEBERA CAMBIAR TAMBIEN EN EL SP [dbo].[AccountSubAccountVCCBatchSummaryCreate]
						DECLARE @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE DECIMAL(5, 2) = 0

						-- RECUPERAMOS LOS DATOS DE REQUEST PROMEDIO Y TASA DE SEGURIDAD RECUPERADAS EN EL SP
						SELECT TOP 1 @AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST = SPR.[CAASPR],
								@AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE = SPR.[CAARPM],
								@COGNITIVE_ANALYSIS_BILLING_SECURE_RATE = SPR.[CABSR]
							FROM @SP_RESULT SPR 

						-- CALCULAMOS EL MONTO PARA ANALISIS COGNITIVO DE LA SIGUIENTE FORMA:
						-- TOTAL MODELS * TARIFA POR TRANSACCION * (TIEMPO TRANSCRITO O TIEMPO TOTAL * PROMEDIO DE REQUEST POR MINUTO / 60) * (1 + TASA DE SEGURO DE FACTURACION)
						-- *TASA DE SEGURO DE FACTURACION: SI SE CAMBIA ESTE VALOR, SE DEBERA CAMBIAR TAMBIEN EN EL SP [dbo].[GetAccountVccRates]
						-- SET @CURRENT_RETAINED_AMOUNT = (@TotalModels * @COGNITIVE_ANALYSIS_RATE_PER_SECOND * @DurationTime * @AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE)) / 60
						-- SET @CURRENT_RETAINED_AMOUNT = CEILING((@TotalModels * @COGNITIVE_ANALYSIS_RATE_PER_SECOND * @ROUNDED_VALID_DURATION_TIME * @AVERAGE_COGNITIVE_ANALYSIS_REQUEST_PER_MINUTE * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE)) / 60)
						-- SET @CURRENT_RETAINED_AMOUNT = @TotalModels * CEILING(@COGNITIVE_ANALYSIS_RATE_PER_SECOND * @DurationTime * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE) / @AVERAGE_COGNITIVE_ANALYSIS_SECONDS_PER_REQUEST) 
						SET @CURRENT_RETAINED_AMOUNT = @TotalModels * CEILING(@COGNITIVE_ANALYSIS_RATE_PER_SECOND * @ModelRequests * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE)) 
						SET @CURRENT_TOTAL_ESTIMATED_MODEL_REQUESTS = @TotalModels * CEILING(@ModelRequests * (1 + @COGNITIVE_ANALYSIS_BILLING_SECURE_RATE))
					END 
				END
				
				--VERIFICAMOS QUE TENEMOS SALDO SUFICIENTE EN LA CARTERA DE TRANSCRICIOPNES DEL VCC
				IF NOT EXISTS (SELECT AVB.[AccountId] 
							FROM [dbo].[AccountVccBalance] AVB (NOLOCK)
							WHERE AVB.[InstallationId] = @InstallationId
								AND AVB.[AccountId] = @AccountID
								AND AVB.[VCC] = @VCC
								AND AVB.[SystemService] = @CURRENT_SYSTEM_SERVICE
								AND AVB.[AvailableBalance] >= @CURRENT_RETAINED_AMOUNT)
					-- SI NO ENCUENTRA RESULTADO, LANZAMOS MENSAJE AVISANDO NO HAY SUFICIENTE SALDO PARA TRANSCRIPCIONES
					RAISERROR('DATABABASE_ERROR_INSUFFICIENT_SYSTEM_SERVICE_BALANCE', 16, 16)

				-- BLOQUEMOS TEMPORALMENTE EL REGISTRO DE SALDOS DEL SERVICO USANDO LOS MISMO PARAMETROS DE BUSQUEDA Y 
				-- ASEGURANDONOS QUE EL SALDO DISPONIBLE AUN ES MAYOR QUE EL SALDO A SETTEAR
				UPDATE [dbo].[AccountVccBalance] 
					SET [IsLocked] = 1,
						[LastModifiedByUserId] = @UserApi,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [InstallationId] = @InstallationId
						AND [AccountId] = @AccountID
						AND [VCC] = @VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE
						AND [AvailableBalance] >= @CURRENT_RETAINED_AMOUNT
			
				IF @@ROWCOUNT = 0
					RAISERROR('DATABABASE_ERROR_INSUFFICIENT_SYSTEM_SERVICE_BALANCE', 16, 16)

				-- UNA VEZ BLOQUEADO EL REGISTRO DE LA TABLA ACCOUNTVCCBALANCE, REGISTRAMOS LAS SALIDAS Y ENTRADAS EN 
				-- LA TABLA DE MOVIMIENTOS ACCOUNSUBACCOUNTVCCBALANCEMOVEMENT (MOVIMIENTO DE SERVICIO TARGET -> FREE)
				-- DEFINIMOS LA DESCRIPCION DEL MOVIMIENTO PARA ESTE BLOQUE
				SET @MOVEMENT_DESCRIPTION = CONCAT('VCC ', @VCC, ': RETAIN $', @CURRENT_RETAINED_AMOUNT, ' FROM ', @CURRENT_SYSTEM_SERVICE, ' WALLET ON CREATING BATCH') 

				-- INCREMENTAMOS EN 1 EL PASO EN QUE NOS ENCONTRAMOS
				SET @BATCH_CURRENT_STEP = @BATCH_CURRENT_STEP + 1

				-- INSERTAMOS EN LA TABLA ACCOUNSUBACCOUNTVCCBALANCEMOVEMENT EL REGISTRO PARA LA RETENCION DE LA CARTERA TRANSCRIPTION
				INSERT INTO [dbo].[AccountSubAccountVCCBalanceMovement] 
							([ID] ,[InstallationId] ,[AccountId] ,[SubAccountId] ,[VCC]
							,[Wallet] ,[Type] ,[CurrentStep] ,[TotalSteps] ,[Description]
							,[BatchId] ,[Amount]
							,[PrevAvailableBalance] ,[PostAvailableBalance] 
							,[PrevCountableBalance] ,[PostCountableBalance] 
							,[TimeStamp])
					SELECT @ID ,AVB.[InstallationId] ,AVB.[AccountId] ,AVB.[SubAccountId] ,AVB.[VCC]
							,AVB.[SystemService] ,'RETAIN' ,@BATCH_CURRENT_STEP ,@BATCH_TOTAL_STEPS ,@MOVEMENT_DESCRIPTION
							,@ID ,@CURRENT_RETAINED_AMOUNT
							,AVB.[AvailableBalance] ,AVB.[AvailableBalance] - @CURRENT_RETAINED_AMOUNT 
							,AVB.[CountableBalance] ,AVB.[CountableBalance]
							,GETUTCDATE()
						FROM [dbo].[AccountVCCBalance] AVB (NOLOCK)
						WHERE [InstallationId] = @InstallationId 
							AND [AccountId] = @AccountId
							AND [VCC] = @VCC
							AND [SystemService] = @CURRENT_SYSTEM_SERVICE
							AND [AvailableBalance] > @CURRENT_RETAINED_AMOUNT

				-- VARIAMOS EL INSERT SEGUN EL SERVICIO DEL SISTEMA
				IF @CURRENT_SYSTEM_SERVICE = 'TRANSCRIPTION'
				BEGIN
					-- INSERTAMOS EL PAQUETE DE TRANSCRIPCION EN LA TABLA GENERAL DE TRANSACCION
					INSERT INTO [dbo].[AccountSubAccountVCCSummaryTransaction] (
						[BatchID] ,[InstallationId] ,[VCC] ,[SystemService] ,[TotalAudio] 
						,[DurationTime] ,[AlreadyTranscribedAudio] ,[AlreadyDurationTime] ,[AlreadyRoundedDurationTime] ,[AlreadyTranscribedDurationTime] 
						,[AlreadyTranscribedRoundedDurationTime] ,[TranscriptionRatePerSecond] ,[BatchTypeName] ,[BatchTypeId] ,[ProcessId] 
						,[UserApi] ,[StartDate] ,[CreatedDate] ,[CreatedByuserId] ,[TimeStamp]
					)
					VALUES (
						@ID ,@InstallationId ,@VCC ,@CURRENT_SYSTEM_SERVICE ,@TotalAudio 
						,@DurationTime ,@AlreadyTranscribedAudio ,@AlreadyDurationTime ,@AlreadyRoundedDurationTime ,@AlreadyTranscribedDurationTime 
						,@AlreadyTranscribedRoundedDurationTime ,@TRANSCRIPTION_RATE_PER_SECOND ,@BatchTypeName ,@BatchTypeId ,@ProcessId 
						,@UserApi ,@StartDate ,GETUTCDATE() , @UserApi ,GETUTCDATE()
					)
			
					-- LANZAMOS MENSAJE DE ERROR SI HUBO FALLA AL INSERTAR EL PAQUETE DE TRANSCRIPCION
					IF @@ROWCOUNT = 0
						RAISERROR('DATABABASE_ERROR_TRANSCRIPTION_SERVICE_PACKAGE_SAVE_FAILED', 16, 16)
				END 

				IF @CURRENT_SYSTEM_SERVICE = 'SEMANTIC_ANALYSIS' 
				BEGIN
					-- INSERTAMOS EL PAQUETE DE TRANSCRIPCION EN LA TABLA GENERAL DE TRANSACCION
					INSERT INTO [dbo].[AccountSubAccountVCCSummaryTransaction] (
						[BatchID] ,[InstallationId] ,[VCC] ,[SystemService] ,[TotalAudio] 
						,[ValidDurationTime] ,[DurationTime] ,[RoundedDurationTime] ,[TotalQueries] ,[SemanticAnalysisRatePerTransaction] 
						,[BatchTypeName] ,[BatchTypeId] ,[ProcessId] ,[TemplateId] ,[UserApi] 
						,[StartDate] ,[CreatedDate] ,[CreatedByuserId] ,[TimeStamp]
					)
					VALUES (
						@ID ,@InstallationId ,@VCC ,@CURRENT_SYSTEM_SERVICE ,@TotalAudio 
						,@VALID_DURATION_TIME ,@DurationTime, @ROUNDED_VALID_DURATION_TIME ,@TotalQueries ,@SEMANTIC_ANALYSIS_RATE_PER_SECOND 
						,@BatchTypeName ,@BatchTypeId ,@ProcessId ,@TemplateId ,@UserApi 
						,@StartDate ,GETUTCDATE() ,@UserApi ,GETUTCDATE()
					)
			
					-- LANZAMOS MENSAJE DE ERROR SI HUBO FALLA AL INSERTAR EL PAQUETE DE TRANSCRIPCION
					IF @@ROWCOUNT = 0
						RAISERROR('DATABABASE_ERROR_SEMANTIC_ANALYSIS_SERVICE_PACKAGE_SAVE_FAILED', 16, 16)
				END
				
				IF @CURRENT_SYSTEM_SERVICE = 'COGNITIVE_ANALYSIS' 
				BEGIN
					-- INSERTAMOS EL PAQUETE DE TRANSCRIPCION EN LA TABLA GENERAL DE TRANSACCION
					INSERT INTO [dbo].[AccountSubAccountVCCSummaryTransaction] (
						[BatchID] ,[InstallationId] ,[VCC] ,[SystemService] ,[TotalAudio] 
						,[ValidDurationTime] ,[DurationTime] ,[RoundedDurationTime] ,[TotalModels] ,[EstimatedRequestsPerModel]
						,[EstimatedModelRequests] ,[CognitiveAnalysisRatePerTransaction] ,[BatchTypeName] ,[BatchTypeId] ,[ProcessId] 
						,[TemplateId] ,[UserApi] ,[StartDate] ,[CreatedDate] ,[CreatedByuserId] 
						,[TimeStamp]
					)
					VALUES (
						@ID ,@InstallationId ,@VCC ,@CURRENT_SYSTEM_SERVICE ,@TotalAudio 
						,@VALID_DURATION_TIME ,@DurationTime ,@ROUNDED_VALID_DURATION_TIME ,@TotalModels ,@ModelRequests
						,@CURRENT_TOTAL_ESTIMATED_MODEL_REQUESTS ,@COGNITIVE_ANALYSIS_RATE_PER_SECOND ,@BatchTypeName ,@BatchTypeId ,@ProcessId 
						,@TemplateId ,@UserApi ,@StartDate ,GETUTCDATE() ,@UserApi 
						,GETUTCDATE()
					)
			
					-- LANZAMOS MENSAJE DE ERROR SI HUBO FALLA AL INSERTAR EL PAQUETE DE TRANSCRIPCION
					IF @@ROWCOUNT = 0
						RAISERROR('DATABABASE_ERROR_COGNITIVE_ANALYSIS_SERVICE_PACKAGE_SAVE_FAILED', 16, 16)
				END

				-- DESBLOQUEMOS EL REGISTRO DE SALDOS DEL SERVICO USANDO LOS MISMOS PARAMETROS DE BUSQUEDA Y ACTUALIZAMOS EL SALDO DISPONIBLE
				UPDATE [dbo].[AccountVccBalance] 
					SET [IsLocked] = 1,
						[LastModifiedByUserId] = @UserApi,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [InstallationId] = @InstallationId
						AND [AccountId] = @AccountID
						AND [VCC] = @VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE
						AND [AvailableBalance] >= @CURRENT_RETAINED_AMOUNT

				-- DESBLOQUEMOS EL REGISTRO DE SALDOS DEL SERVICO USANDO LOS MISMO PARAMETROS DE BUSQUEDA Y ACTUALIZAMOS EL SALDO DISPONIBLE Y CONTABLE
				UPDATE [dbo].[AccountVCCBalance] 
					SET [IsLocked] = 0, 
						[AvailableBalance] = [AvailableBalance] - @CURRENT_RETAINED_AMOUNT,
						[RetainedBalance] = [RetainedBalance] + @CURRENT_RETAINED_AMOUNT,
						[LastModifiedByUserId] = @UserApi,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE() 
					WHERE [InstallationId] = @InstallationId 
						AND [AccountId] = @AccountId
						AND [VCC] = @VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE
						AND [AvailableBalance] > @CURRENT_RETAINED_AMOUNT

				IF @@ROWCOUNT = 0
					RAISERROR('DATABABASE_ERROR_INSUFFICIENT_SYSTEM_SERVICE_BALANCE', 16, 16)

			END 
			FETCH NEXT FROM MY_CURSOR INTO @CURRENT_SYSTEM_SERVICE
		END
		CLOSE MY_CURSOR
		DEALLOCATE MY_CURSOR

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

END
GO
PRINT N'Refreshing [dbo].[AccountSubAccountDeactivate]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[AccountSubAccountDeactivate]';


GO
PRINT N'Refreshing [dbo].[AccountSubAccountVCCBulkCloseBatchDetail]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[AccountSubAccountVCCBulkCloseBatchDetail]';


GO
PRINT N'Refreshing [dbo].[AccountSubAccountVCCBulkNewBatchDetail]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[AccountSubAccountVCCBulkNewBatchDetail]';


GO
PRINT N'Refreshing [dbo].[GetAccountSubAccountVCCBatchSummaryId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAccountSubAccountVCCBatchSummaryId]';


GO
PRINT N'Refreshing [dbo].[GetMovements]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetMovements]';


GO
PRINT N'Refreshing [dbo].[GetPlatformCancelledBatches]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPlatformCancelledBatches]';


GO
PRINT N'Refreshing [dbo].[GetPlatformCurrentBatches]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPlatformCurrentBatches]';


GO
PRINT N'Refreshing [dbo].[ReportByVCCBalanceByPeriod]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportByVCCBalanceByPeriod]';


GO
PRINT N'Refreshing [dbo].[ReportByVCCBalanceSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportByVCCBalanceSummary]';


GO
PRINT N'Refreshing [dbo].[ReportConsumeDetailByEntity]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportConsumeDetailByEntity]';


GO
PRINT N'Refreshing [dbo].[SaveAccountSubAccountVCCBatchSummaryTransactionStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAccountSubAccountVCCBatchSummaryTransactionStatus]';


GO
PRINT N'Refreshing [dbo].[GetAccountVccRates]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAccountVccRates]';


GO
PRINT N'Update complete.';


GO
