PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_CreatedDate]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_CreatedDate];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_IsFinished]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_IsFinished];


GO
PRINT N'Dropping [dbo].[DF_AccountSubAccountVCCSummaryTransaction_ValidTotalAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction] DROP CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_ValidTotalAudio];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_CreatedByRemoteUser]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_CreatedByRemoteUser] DEFAULT ((1)) FOR [CreatedByRemoteUser];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_CreatedDate]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_CreatedDate] DEFAULT (getutcdate()) FOR [CreatedDate];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_DurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_DurationTime] DEFAULT ((0)) FOR [DurationTime];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_InvalidTotalAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_InvalidTotalAudio] DEFAULT ((0)) FOR [InvalidTotalAudio];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_IsFinished]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_IsFinished] DEFAULT ((0)) FOR [IsFinished];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_TotalAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalAudio] DEFAULT ((0)) FOR [TotalAudio];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_TotalModels]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalModels] DEFAULT ((0)) FOR [TotalModels];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_TotalQueries]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_TotalQueries] DEFAULT ((0)) FOR [TotalQueries];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_ValidDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidDurationTime] DEFAULT ((0)) FOR [ValidDurationTime];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_ValidTotalAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalAudio] DEFAULT ((0)) FOR [ValidTotalAudio];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_ValidTotalModels]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalModels] DEFAULT ((0)) FOR [ValidTotalModels];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCGeneralTransaction_ValidTotalQueries]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCGeneralTransaction_ValidTotalQueries] DEFAULT ((0)) FOR [ValidTotalQueries];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadeTranscribedRoundedDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadeTranscribedRoundedDurationTime] DEFAULT ((0)) FOR [AlreadyTranscribedRoundedDurationTime];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadyDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyDurationTime] DEFAULT ((0)) FOR [AlreadyDurationTime];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadyRoundedDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyRoundedDurationTime] DEFAULT ((0)) FOR [AlreadyRoundedDurationTime];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedAudio]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedAudio] DEFAULT ((0)) FOR [AlreadyTranscribedAudio];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_AlreadyTranscribedDurationTime] DEFAULT ((0)) FOR [AlreadyTranscribedDurationTime];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_ModelRequest]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_ModelRequest] DEFAULT ((0)) FOR [TotalModelRequest];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_QueryRequest]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_QueryRequest] DEFAULT ((0)) FOR [TotalQueryRequest];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_RoundedDurationTime]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_RoundedDurationTime] DEFAULT ((0)) FOR [RoundedDurationTime];


GO
PRINT N'Creating [dbo].[DF_AccountSubAccountVCCSummaryTransaction_StimatedRequestsPerModel]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_AccountSubAccountVCCSummaryTransaction_StimatedRequestsPerModel] DEFAULT ((0)) FOR [EstimatedRequestsPerModel];


GO
PRINT N'Creating [dbo].[DF_Table_1_ID]...';


GO
ALTER TABLE [dbo].[AccountSubAccountVCCSummaryTransaction]
    ADD CONSTRAINT [DF_Table_1_ID] DEFAULT (newid()) FOR [BatchID];


GO
PRINT N'Altering [dbo].[AccountSubAccountVCCBatchSummaryClose]...';


GO
ALTER PROCEDURE [dbo].[AccountSubAccountVCCBatchSummaryClose](
	@BatchId VARCHAR(50) = NULL, 
	@ClosedDate DATETIME = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
		IF @BatchId IS NULL 
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS SYSTEMSERVICE RELACIONADOS AL BATCH
		DECLARE MY_CURSOR CURSOR 
		LOCAL STATIC READ_ONLY FORWARD_ONLY
			FOR 
			-- CONSULTAMOS LOS SYSTEMSERVICE DEL BATCH PARA LA ACTUALIZACION DE SALDOS
			SELECT ASAVST.[InstallationId],
					ASAVST.[VCC], 
					ASAVST.[SystemService], 
					ASAVST.[Rate]
				FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST 
				WHERE ASAVST.[BatchID] = @BatchId

		-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL BACTH ACTUAL QUE ESTAMOS RECORRIENDO
		DECLARE @CURRENT_INSTALLATION_ID VARCHAR(50) = ''
		DECLARE @CURRENT_VCC VARCHAR(50) = ''
		DECLARE @CURRENT_SYSTEM_SERVICE VARCHAR(50) = ''
		DECLARE @CURRENT_RATE DECIMAL(18, 5) = 0

		-- DECLARAMOS VARIABLES DE AYUDA QUE CAMBIARAN EN EL BUCLE
		DECLARE @MOVEMENT_DESCRIPTION VARCHAR(250) = NULL
		DECLARE @BATCH_TOTAL_STEPS INT = 0
		DECLARE @BATCH_CURRENT_STEP INT = 0
		DECLARE @INITIAL_CALCULATED_AMOUNT DECIMAL(18,5) = 0
		DECLARE @FINAL_CALCULATED_AMOUNT DECIMAL(18,5) = 0

		
		-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
		OPEN MY_CURSOR
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_INSTALLATION_ID, @CURRENT_VCC, @CURRENT_SYSTEM_SERVICE, @CURRENT_RATE
		WHILE @@FETCH_STATUS = 0
		BEGIN 
			-- OBTENEMOS LOS DATOS GENERALES DEL BATCH EN LA TABLA DE MOVIMIENTOS
			SELECT @BATCH_CURRENT_STEP = MAX(ASAVBM.[CurrentStep]),
					@BATCH_TOTAL_STEPS = ASAVBM.[TotalSteps]
				FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK)
				WHERE ASAVBM.[BatchID] = @BatchId
				GROUP BY ASAVBM.[InstallationId], ASAVBM.[VCC], ASAVBM.[TotalSteps]

			-- OBTENEMOS LOS DATOS ESPECIFICOS DEL BATCH-SYSTEMSERVICE EN LA TABLA DE MOVIMIENTOS
			SELECT @INITIAL_CALCULATED_AMOUNT = ASAVBM.[Amount]
				FROM [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK)
				WHERE ASAVBM.[BatchID] = @BatchId
					AND ASAVBM.[InstallationId] = @CURRENT_INSTALLATION_ID
					AND ASAVBM.[Wallet] = @CURRENT_SYSTEM_SERVICE

			-- PARA REGISTRAR LOS MOVIMIENTOS AUMENTAMOS EL CURRENT_STEP PARA REGISTRAR EL SIGUIENTE MOVIMIENTO
			SET @BATCH_CURRENT_STEP = @BATCH_CURRENT_STEP + 1

			-- DEFINIMOS LA DESCRIPCION DEL MOVIMIENTO DEBITAJE
			SET @MOVEMENT_DESCRIPTION = CONCAT('VCC ', @CURRENT_VCC, ': DEBT $', @CURRENT_RATE, ' FROM ', @CURRENT_SYSTEM_SERVICE, ' WALLET ON CLOSING BATCH')

			-- INSERTAMOS EN LA TABLA ACCOUNSUBACCOUNTVCCBALANCEMOVEMENT EL REGISTRO PARA EL COBRO A LA CARTERA RECORRIDA
			INSERT INTO [dbo].[AccountSubAccountVCCBalanceMovement] 
						([ID] ,[InstallationId] ,[AccountId] ,[SubAccountId] ,[VCC]
						,[Wallet] ,[Type] ,[CurrentStep] ,[TotalSteps] ,[Description]
						,[BatchId] ,[Amount]
						,[PrevAvailableBalance] ,[PostAvailableBalance] 
						,[PrevCountableBalance] ,[PostCountableBalance] 
						,[TimeStamp])
				SELECT @BatchId ,AVB.[InstallationId] ,AVB.[AccountId] ,AVB.[SubAccountId] ,AVB.[VCC]
						,AVB.[SystemService] ,'DEBT' ,@BATCH_CURRENT_STEP ,@BATCH_TOTAL_STEPS ,@MOVEMENT_DESCRIPTION
						,@BatchId ,@CURRENT_RATE
						,AVB.[AvailableBalance] ,AVB.[AvailableBalance]
						,AVB.[CountableBalance] ,AVB.[CountableBalance] - @CURRENT_RATE 
						,GETUTCDATE()
					FROM [dbo].[AccountVCCBalance] AVB (NOLOCK)
					WHERE [InstallationId] = @CURRENT_INSTALLATION_ID 
						AND [VCC] = @CURRENT_VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE
						--AND [CountableBalance] > @FINAL_CALCULATED_AMOUNT

			-- DESBLOQUEMOS EL REGISTRO DE SALDOS DEL SERVICO USANDO LOS MISMO PARAMETROS DE BUSQUEDA Y ACTUALIZAMOS EL SALDO DISPONIBLE Y CONTABLE
			UPDATE [dbo].[AccountVCCBalance] 
				SET [IsLocked] = 0, 
					[AvailableBalance] = [AvailableBalance] + (@INITIAL_CALCULATED_AMOUNT - @CURRENT_RATE),
					[RetainedBalance] = [RetainedBalance] - @INITIAL_CALCULATED_AMOUNT,
					[CountableBalance] = [CountableBalance] - @CURRENT_RATE,
					--[LastModifiedByUserId] = @UserApi,
					[LastModifiedDate] = GETUTCDATE(),
					[TimeStamp] = GETUTCDATE() 
				WHERE [InstallationId] = @CURRENT_INSTALLATION_ID 
					AND [VCC] = @CURRENT_VCC
					AND [SystemService] = @CURRENT_SYSTEM_SERVICE

			-- AUMENTAMOS EL CURRENT_STEP PARA REGISTRAR EL SIGUIENTE MOVIMIENTO
			SET @BATCH_CURRENT_STEP = @BATCH_CURRENT_STEP + 1

			-- DEFINIMOS LA DESCRIPCION DEL MOVIMIENTO LIBERAR
			SET @MOVEMENT_DESCRIPTION = CONCAT('VCC ', @CURRENT_VCC, ': RELEASE $', (@INITIAL_CALCULATED_AMOUNT - @CURRENT_RATE), ' FROM ', @CURRENT_SYSTEM_SERVICE, ' WALLET ON CLOSING BATCH')
			
			-- INSERTAMOS EN LA TABLA ACCOUNSUBACCOUNTVCCBALANCEMOVEMENT EL REGISTRO PARA LA LIBERACION DE SALDO RETENIDO A LA CARTERA RECORRIDA
			INSERT INTO [dbo].[AccountSubAccountVCCBalanceMovement] 
						([ID] ,[InstallationId] ,[AccountId] ,[SubAccountId] ,[VCC]
						,[Wallet] ,[Type] ,[CurrentStep] ,[TotalSteps] ,[Description]
						,[BatchId] ,[Amount]
						,[PrevAvailableBalance] ,[PostAvailableBalance] 
						,[PrevCountableBalance] ,[PostCountableBalance] 
						,[TimeStamp])
				SELECT @BatchId ,AVB.[InstallationId] ,AVB.[AccountId] ,AVB.[SubAccountId] ,AVB.[VCC]
						,AVB.[SystemService] ,'RELEASE' ,@BATCH_CURRENT_STEP ,@BATCH_TOTAL_STEPS ,@MOVEMENT_DESCRIPTION
						,@BatchId ,@INITIAL_CALCULATED_AMOUNT - @CURRENT_RATE
						,AVB.[AvailableBalance] ,AVB.[AvailableBalance] + (@INITIAL_CALCULATED_AMOUNT - @CURRENT_RATE)
						,AVB.[CountableBalance] ,AVB.[CountableBalance] 
						,GETUTCDATE()
					FROM [dbo].[AccountVCCBalance] AVB (NOLOCK)
					WHERE [InstallationId] = @CURRENT_INSTALLATION_ID 
						AND [VCC] = @CURRENT_VCC
						AND [SystemService] = @CURRENT_SYSTEM_SERVICE

			-- ACTUALIZAR EL BATCH COMO ISFINISHED TRUE EN CASO NO HAYA SIDO MARCADO TODAVIA
			UPDATE [dbo].[AccountSubAccountVCCSummaryTransaction]
				SET [IsFinished] = 1,
					[EndDate] = CASE WHEN @ClosedDate IS NULL THEN [EndDate] ELSE @ClosedDate END,
					[Status] = CASE WHEN [Status] LIKE 'CANCELLED%' THEN 'FINISHED_BY_CANCELLED' ELSE 'FINISHED' END, 
					--[Status] = 'FINISHED', -- ESTE ESTADO SE CAMBIARA PARA DAR OPCION A FINISHED COMO COMPLETADO SIN INTERVENSION O FINISHED_BY_USER CUANDO EL USUARIO DECIDE TERMINARLO
					[LasModifiedDate] = GETUTCDATE(),
					[TimeStamp] = GETUTCDATE()
				WHERE [InstallationId] = @CURRENT_INSTALLATION_ID 
					AND [BatchID] = @BatchId
					AND [VCC] = @CURRENT_VCC
					AND [SystemService] = @CURRENT_SYSTEM_SERVICE
					--AND [IsFinished] = 0
					AND [Status] NOT IN ('FINISHED', 'FINISHED_BY_CANCELLED')

			FETCH NEXT FROM MY_CURSOR INTO @CURRENT_INSTALLATION_ID, @CURRENT_VCC, @CURRENT_SYSTEM_SERVICE, @CURRENT_RATE
		END
		CLOSE MY_CURSOR
		DEALLOCATE MY_CURSOR

		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[AccountSubAccountVCCBulkUpdateBatchDetail]...';


GO
ALTER PROCEDURE [dbo].[AccountSubAccountVCCBulkUpdateBatchDetail]
AS
BEGIN
	-- INSERT INTO [dbo].[TMP_TABLE_UPDATE] ([PlatformHash], [InstallationId], [AccountId], [SubAccountId], [VCC], [BatchTypeName], [BatchTypeId], [SystemService], [ProcessId], [EntityId], [FieldToUpdate], [ValueToUpdate])
	-- SELECT [PlatformHash], [InstallationId], [AccountId], [SubAccountId], [VCC], [BatchTypeName], [BatchTypeId], [SystemService], [ProcessId], [EntityId], [FieldToUpdate], [ValueToUpdate] FROM #AccountSubAccountVCCBulkUpdateBatchDetailTemp;
	-- SELECT * FROM [dbo].[TMP_TABLE_UPDATE] 
	
	-- ESTE PROCEDURE TIENE LA FUNCION DE ACTUALIZAR UN BLOQUE DE DATA EXISTENTE EN LA TABLA DETALLE DE TRANSACCION
	-- A PARTIR DE UNA TABLA TEMPORAL
	
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS TIPOS DE UPDATE
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY
		FOR 
		SELECT DISTINCT ASAVDTTMP.[FieldToUpdate]
			-- FROM TMP_TABLE_UPDATE ASAVDTTMP 
			FROM #AccountSubAccountVCCBulkUpdateBatchDetailTemp ASAVDTTMP (NOLOCK)

	-- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS ACTUALIZANDO
	DECLARE @CURRENT_FIELD_TO_UPDATE VARCHAR(50) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_FIELD_TO_UPDATE
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		--declare @CURRENT_FIELD_TO_UPDATE varchar(50) = 'TotalValidRequest';
		WITH 
		-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DEL RESUMEN DE ACTUALIZACION
		CteTransactionDetailUpdate AS (
			SELECT ASAVDTTMP.[InstallationId]
					,ASAVDTTMP.[VCC]
					,ASAVDTTMP.[BatchTypeName]
					,ASAVDTTMP.[BatchTypeId]
					,ASAVDTTMP.[SystemService]
					,ASAVDTTMP.[EntityId] 
					,ASAVDTTMP.[FieldToUpdate]
					,CASE 
						WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalValidRequest' THEN CAST(COUNT(ASAVDTTMP.[ValueToUpdate]) AS VARCHAR(10)) 
						WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalInvalidRequest' THEN CAST(COUNT(ASAVDTTMP.[ValueToUpdate]) AS VARCHAR(10)) 
						ELSE ASAVDTTMP.[ValueToUpdate] END 'ValueToUpdate'
			-- FROM TMP_TABLE_UPDATE ASAVDTTMP (NOLOCK)
			FROM #AccountSubAccountVCCBulkUpdateBatchDetailTemp ASAVDTTMP (NOLOCK)
			WHERE ASAVDTTMP.[FieldToUpdate] = @CURRENT_FIELD_TO_UPDATE
			GROUP BY ASAVDTTMP.[InstallationId]
				,ASAVDTTMP.[VCC]
				,ASAVDTTMP.[BatchTypeName]
				,ASAVDTTMP.[BatchTypeId]
				,ASAVDTTMP.[SystemService]
				,ASAVDTTMP.[EntityId] 
				,ASAVDTTMP.[FieldToUpdate]
				,ASAVDTTMP.[ValueToUpdate] 
		)
		-- SELECT * FROM CteTransactionDetailUpdate
		
		-- HACEMOS EL UPDATE DE LA TABLA TRANSACTION DETAILED CRUZANDO CON LA CTE DE LA TEMPORAL UPDATE
		UPDATE ASAVDT
		SET --ASAVDT.[AccountId] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'AccountId' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[AccountId] END,
			ASAVDT.[ApiId] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'ApiId' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[ApiId] END,
			ASAVDT.[IsDemo] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'IsDemo' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[IsDemo] END,
			-- ASAVDT.[ValidDurationTime] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'ValidDurationTime' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[ValidDurationTime] END,
			ASAVDT.[ValidDurationTime] = 
				CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'ValidDurationTime' 
				THEN CASE
					WHEN ASAVDTTMP.[ValueToUpdate] <> 'null' THEN ASAVDTTMP.[ValueToUpdate] ELSE 0 END
				ELSE ASAVDT.[ValidDurationTime] END,
			ASAVDT.[TotalRequest] = CASE 
				WHEN (ASAVDTTMP.[SystemService] = 'COGNITIVE_ANALYSIS' AND ASAVDTTMP.[FieldToUpdate] = 'TotalValidRequest') THEN ASAVDT.[TotalRequest] + ASAVDTTMP.[ValueToUpdate] 
				WHEN (ASAVDTTMP.[SystemService] = 'SEMANTIC_ANALYSIS' AND ASAVDTTMP.[FieldToUpdate] = 'TotalPages') THEN ASAVDTTMP.[ValueToUpdate] 
				ELSE ASAVDT.[TotalRequest] END,
			ASAVDT.[TotalValidRequest] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalValidRequest' THEN ASAVDT.[TotalValidRequest] + ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalValidRequest] END,
			ASAVDT.[TotalInvalidRequest] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalInvalidRequest' THEN ASAVDT.[TotalInvalidRequest] + ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalInvalidRequest] END,
			ASAVDT.[TotalItems] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalResults' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalItems] END,
			ASAVDT.[TotalPages] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalPages' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[TotalPages] END,
			ASAVDT.[ItemsPerPage] = CASE WHEN ASAVDTTMP.[FieldToUpdate] = 'TotalItemsPerPage' THEN ASAVDTTMP.[ValueToUpdate] ELSE ASAVDT.[ItemsPerPage] END,
			ASAVDT.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT 
		INNER JOIN CteTransactionDetailUpdate ASAVDTTMP
			ON ASAVDTTMP.[InstallationId] = ASAVDT.[InstallationId]
				AND ASAVDTTMP.[VCC] = ASAVDT.[VCC]
				AND ASAVDTTMP.[BatchTypeName] = ASAVDT.[BatchTypeName]
				AND ASAVDTTMP.[BatchTypeId] = ASAVDT.[BatchTypeId]
				AND ASAVDTTMP.[SystemService] = ASAVDT.[SystemService]
				AND ASAVDTTMP.[EntityId] = ASAVDT.[EntityId]
		WHERE ASAVDTTMP.[InstallationId] IS NOT NULL
			AND ASAVDTTMP.[FieldToUpdate] = @CURRENT_FIELD_TO_UPDATE
			--AND ASAVDT.[IsFinished] <> 1

		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_FIELD_TO_UPDATE
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR

	-- TERMINADO EL PROCESO ELIMINAMOS LA TABLA TEMPORAL*/
	DROP TABLE #AccountSubAccountVCCBulkUpdateBatchDetailTemp
	
END
GO
PRINT N'Altering [dbo].[GetAccountSubAccountVCCBalance]...';


GO
ALTER PROCEDURE [dbo].[GetAccountSubAccountVCCBalance] (
	@PlatformHash VARCHAR(100) = NULL,
	@InstallationId VARCHAR(50) = NULL,
	@AccountId VARCHAR(50) = NULL,
	@SubAccountId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@SystemService VARCHAR(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- VERIFICAMOS SI EXISTE UNA PLATAFORMA CON EL PLATFORMHASH INGRESADO
	IF NOT EXISTS(
		SELECT P.[PlatformHash] 
			FROM dbo.[Platform] P 
			WHERE P.[PlatformHash] = @PlatformHash
				AND P.[InstallationId] = @InstallationId
	)
	BEGIN
		-- SI NO EXISTE LA PLATAFORMA ENVIAMOS UN MENSAJE DE ERROR
		RAISERROR('DATABABASE_ERROR_NOT_FOUND_PLATAFORM', 16, 16)
		RETURN
	END

	-- VERIFICAMOS SI SUBACCOUNID ES NULL PARA LA VALIDACION DE CUENTA/SUBCUENTA
	IF @SubAccountId IS NULL 
	BEGIN
		-- SI SUBCUENTA ES NULL, SOLO VERIFICAMOS SI EXISTE LA CUENTA
		IF NOT EXISTS(
			SELECT A.[AccountId] 
				FROM dbo.[Account] A 
				WHERE A.[PlatformHash] = @PlatformHash
					AND A.[InstallationId] = @InstallationId 
					AND A.[AccountId] = @AccountId
					AND A.[SubAccountId] IS NULL
		)
		BEGIN
			-- SI NO EXISTE LA CUENTA ENVIAMOS UN MENSAJE DE ERROR
			RAISERROR('DATABABASE_ERROR_NOT_FOUND_ACCOUNT', 16, 16)
			RETURN
		END
		ELSE 
		BEGIN
			-- VERIFICAMOS SI EXISTE EL VCC ASOCIADO A LA CUENTA
			IF NOT EXISTS(
				SELECT AV.[VCC] 
					FROM dbo.[AccountVCC] AV 
					WHERE AV.[InstallationId] = @InstallationId 
						AND AV.[AccountId] = @AccountId
						AND AV.[SubAccountId] IS NULL
						AND AV.[VCC] = @VCC
			)	
			BEGIN
				-- SI NO EXISTE LA CUENTA ENVIAMOS UN MENSAJE DE ERROR
				RAISERROR('DATABABASE_ERROR_NOT_FOUND_ACCOUNT_VCC', 16, 16)
				RETURN
			END
		END
	END
	ELSE
	BEGIN 
		-- SI SUBCUENTA ES DIFERENTE DE NULL, VERIFICAMOS SI EXISTE LA CUENTA CON SUBCUENTA ASOCIADA
		IF NOT EXISTS(
			SELECT A.[SubAccountId] 
				FROM dbo.[Account] A 
				WHERE A.[PlatformHash] = @PlatformHash
					AND A.[InstallationId] = @InstallationId 
					AND A.[AccountId] = @AccountId
					AND A.[SubAccountId] = @SubAccountId
		)
		BEGIN
			-- SI NO EXISTE LA PLATAFORMA ENVIAMOS UN MENSAJE DE ERROR
			RAISERROR('DATABABASE_ERROR_NOT_FOUND_SUBACCOUNT', 16, 16)
			RETURN
		END
		ELSE 
		BEGIN
			-- VERIFICAMOS SI EXISTE EL VCC ASOCIADO A LA CUENTA-SUBCUENTA
			IF NOT EXISTS(
				SELECT AV.[VCC] 
					FROM dbo.[AccountVCC] AV 
					WHERE AV.[InstallationId] = @InstallationId 
						AND AV.[AccountId] = @AccountId
						AND AV.[SubAccountId] = @SubAccountId
						AND AV.[VCC] = @VCC
			)	
			BEGIN
				-- SI NO EXISTE LA CUENTA ENVIAMOS UN MENSAJE DE ERROR
				RAISERROR('DATABABASE_ERROR_NOT_FOUND_SUBACCOUNT_VCC', 16, 16)
				RETURN
			END
		END
	END;

	-- DECLARAMOS LAS CTE QUE JUNTARAN LA DATA REQUERIDA PARA EL RESULT
	WITH CTE_BATCHES_DETAILED_RATED AS (
		-- HACEMOS SELECT A LOS BATCHES CON POR BATACHID, SYSTEMSERVICE, CON SALDO RETENIDO Y SALDO CONSUMIDO
		SELECT ASAVST.[InstallationId],
				ASAVBM.[AccountId],
				ASAVBM.[SubAccountId],
				ASAVST.[VCC],
				ASAVST.[BatchID],
				ASAVST.[SystemService],
				ASAVBM.[Amount] AS 'Estimated',
				SUM(ASAVDT.[Rate]) AS 'Rated',
				ASAVST.[CreatedDate],
				COUNT(*) AS 'Details'
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
			LEFT JOIN [dbo].[AccountSubAccountVCCDetailedTransaction] ASAVDT (NOLOCK) 
				ON ASAVDT.[BatchId] = ASAVST.[BatchID]
					AND ASAVDT.[SystemService] = ASAVST.[SystemService]
			LEFT JOIN [dbo].[AccountSubAccountVCCBalanceMovement] ASAVBM (NOLOCK)
				ON ASAVBM.[VCC] = ASAVST.[VCC]
					AND ASAVBM.[BatchId] = ASAVST.[BatchID]
					AND ASAVBM.[Wallet] = ASAVST.[SystemService]
			WHERE ASAVST.[InstallationId] = @InstallationId
				AND ASAVBM.[AccountId] = @AccountId
				AND (
					(@SubAccountId IS NULL AND ASAVBM.[SubAccountId] IS NULL)
					OR (ASAVBM.[SubAccountId] = @SubAccountId)
				)
				AND ASAVBM.[VCC] = @VCC
				AND ASAVBM.[Type] = 'RETAIN'
				--AND (ASAVST.[Status] <> 'FINISHED' AND ASAVST.[Status] NOT LIKE 'CANCELLED')
				AND (ASAVST.[Status] NOT LIKE 'FINISHED%')
				AND GETUTCDATE() < DATEADD(DAY, 5, ASAVST.[CreatedDate])
				AND ASAVDT.[IsDemo] = 0
			GROUP BY ASAVST.[InstallationId],
						ASAVBM.[AccountId],
						ASAVBM.[SubAccountId],
						ASAVST.[VCC],
						ASAVST.[BatchID],
						ASAVST.[SystemService],
						ASAVBM.[Amount],
						ASAVST.[CreatedDate]
	),
	CTE_BATCHES_SUMMARY_RATED AS (
		-- HACEMOS SELECT AL RESULTADO ANTERIOR PARA SUMARIZAR EL RATED, ESTIMATED Y DIFFERENCE
		SELECT CTEBDR.[InstallationId],
				CTEBDR.[AccountId],
				CTEBDR.[SubAccountId],
				CTEBDR.[VCC],
				CTEBDR.[SystemService],
				SUM(CTEBDR.[Estimated]) AS 'Estimated',
				SUM(CTEBDR.[Rated]) AS 'Rated'
			FROM CTE_BATCHES_DETAILED_RATED CTEBDR 
			GROUP BY CTEBDR.[InstallationId],
						CTEBDR.[AccountId],
						CTEBDR.[SubAccountId],
						CTEBDR.[VCC],
						CTEBDR.[SystemService]
	)
	
	-- HACEMOS LA BUSQUEDA DE LOS SALDOS DEL CUENTA-SUBCUENTA-VCC
	SELECT AVB.[AccountId]														'accountId', 
			AVB.[SubAccountId]													'subAccountId',
			AVB.[SystemService]													'systemService',
			AVB.[CountableBalance]												'countableBalance',
			AVB.[AvailableBalance]												'availableBalance',
			AVB.[RetainedBalance]												'retainedBalance',
			-- ISNULL(CTEBMR.[Estimated], 0)										'estimated',
			-- ISNULL(CTEBMR.[Rated], 0)											'rated',
			ISNULL(ABS(CTEBMR.[Estimated] - CTEBMR.[Rated]), 0)					'difference',
			CASE WHEN CTEBMR.[Rated] > CTEBMR.[Estimated] THEN 1 ELSE 0 END		'exceeded'
		FROM dbo.[AccountVCCBalance] AVB (NOLOCK)
		LEFT JOIN CTE_BATCHES_SUMMARY_RATED CTEBMR 
			ON CTEBMR.[InstallationId] = AVB.[InstallationId]
				AND CTEBMR.[AccountId] = AVB.[AccountId]
				AND (
					(CTEBMR.[SubAccountId] IS NULL AND AVB.[SubAccountId] IS NULL)
					OR (CTEBMR.[SubAccountId] = AVB.[SubAccountId])
				)
				AND CTEBMR.[VCC] = AVB.[VCC]
				AND CTEBMR.[SystemService] = AVB.[SystemService]
		WHERE AVB.[InstallationId] = @InstallationId 
			AND AVB.[AccountId] = @AccountId
			AND (
				(@SubAccountId IS NULL AND AVB.[SubAccountId] IS NULL)
				OR (AVB.[SubAccountId] = @SubAccountId)
			) 
			AND AVB.[VCC] = @VCC
			AND AVB.[SystemService] = ISNULL(@SystemService, AVB.[SystemService]) 

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetAccountSubAccountVCCBatchSummaryByBatchTypeId]...';


GO
ALTER PROCEDURE [dbo].[GetAccountSubAccountVCCBatchSummaryByBatchTypeId] (
	@PlatformHash VARCHAR(100) = NULL,
	@InstallationId VARCHAR(50) = NULL,
	@VCC VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL
	)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD BUSCAR SI EXISTEN REGISTROS DE UN BATCHID
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
		IF @PlatformHash IS NULL 
			OR @InstallationId IS NULL 
			OR @VCC IS NULL
			OR @BatchTypeName IS NULL
			OR @BatchTypeId IS NULL
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		-- HACEMOS LA BUSQUEDA POR BATCHTYPEID
		SELECT ASAVST.[BatchTypeId] 
			FROM [dbo].[AccountSubAccountVCCSummaryTransaction] ASAVST (NOLOCK)
			WHERE ASAVST.[InstallationId] = @InstallationId
				AND ASAVST.[VCC] =  @VCC
				AND ASAVST.[BatchTypeName] = @BatchTypeName
				AND ASAVST.[BatchTypeId] =  @BatchTypeId

	END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Update complete.';


GO
